'Compilable Example:
#Compiler PBWin 10
#Compile Exe "gbduplicatefilefinder.exe"
#Debug Error On
#Debug Display On
#Dim All
%Unicode = 1
#Include "win32api.inc"
#Include "wininet.inc"

#Resource Manifest, 1, "files\xptheme.xml"
#Resource Icon, aaa, "files\logo.ico"
#Resource Icon, xfolder, "files\open.ico"
#Resource Icon, xsubfolders, "files\subfolders2.ico"
#Resource Icon, xdupes, "files\match.ico"
#Resource Icon, xsettings, "files\settings.ico"
#Resource Icon, xhelp, "files\help.ico"
#Resource Icon, xsearch, "files\search.ico"
#Resource Icon, xname, "files\name.ico"
#Resource Icon, xbytes, "files\bytes.ico"
#Resource Icon, xdelete, "files\delete2.ico"
#Resource Icon, xadd, "files\new.ico"
#Resource Icon, xdate "files\date.ico"
#Resource Icon, xfont "files\font.ico"
#Resource Icon, xredo "files\redo.ico"
#Resource Icon, xunsupported "files\unsupported.ico"
#Resource Icon, xtop "files\top.ico"
#Resource Icon, xmid "files\mid.ico"
#Resource Icon, xbottom "files\bottom.ico"
#Resource Icon, xremove "files\delete.ico"
#Resource Icon, xviewer "files\viewer.ico"
#Resource Icon, xinternal "files\internal.ico"

'iResult& = SendMessage(hEdit, %EM_SetLimitText, 10,0)     'FFFF=64K    FFFFF=1M   FFFFFFFF = 4G

#Link "files\gbmultiviewer.sll"
Declare Function PATHMATCHSPEC Lib "SHLWAPI.DLL" Alias "PathMatchSpecA" ( pszFile As AsciiZ, pszSpec As AsciiZ ) As Long
$Ver = "1.06"

'=============================
Type GdiplusStartupInput Dword
   GdiplusVersion           As Dword
   DebugEventCallback       As Dword
   SuppressBackgroundThread As Long
   SuppressExternalCodecs   As Long
End Type

Type GdiplusStartupOutput Dword
   NotificationHook   As Dword
   NotificationUnhook As Dword
End Type

Declare Function GdiplusStartup Lib "gdiplus.dll" Alias "GdiplusStartup" (ByRef token As Dword, ByRef Input As GdiplusStartupInput, ByRef Output As GdiplusStartupOutput) As Long
Declare Sub GdiplusShutdown Lib "gdiplus.dll" Alias "GdiplusShutdown" (ByVal token As Dword)
Declare Function GdipLoadImageFromFile Lib "gdiplus.dll" Alias "GdipLoadImageFromFile" (ByVal filename As Dword, ByRef Image As Dword) As Long
Declare Function GdipGetImageWidth Lib "GDIPLUS.DLL" Alias "GdipGetImageWidth" (ByVal Image As Dword, ByRef Width As Dword) As Long
Declare Function GdipGetImageHeight Lib "GDIPLUS.DLL" Alias "GdipGetImageHeight" (ByVal Image As Dword, ByRef height As Dword) As Long
Declare Function GdipCreateFromHDC Lib "gdiplus.dll" Alias "GdipCreateFromHDC" (ByVal hdc As Dword, ByRef graphics As Dword) As Long
Declare Function GdipDrawImage Lib "gdiplus.dll" Alias "GdipDrawImage"(ByVal graphics As Dword, ByVal Image As Dword, ByVal x As Single, ByVal y As Single) As Long                                              ' GpStatus
Declare Function GdipDisposeImage Lib "gdiplus.dll" Alias "GdipDisposeImage" (ByVal Image As Dword) As Long
Declare Function GdipDeleteGraphics Lib "gdiplus.dll" Alias "GdipDeleteGraphics" (ByVal graphics As Dword) As Long
'=============================

Type CustomColors
   c(15) As Long
End Type

Enum Equates Singular
   IDT_FolderNew  = 500
   IDT_FolderDel
   IDT_Search
   IDT_Dupes
   IDT_Redo
   IDT_Remove
   IDT_ViewGroup
   IDT_Name
   IDT_Bytes
   IDT_SubFolders
   IDT_InternalViewer
   IDT_Date
   IDT_Font
   IDT_Settings
   IDT_Help

   IDC_ComboFileSpec
   IDC_Label
   IDC_LVResults
   IDC_LVPaths
   IDC_Toolbar
   IDC_StatusBar
   IDC_Viewer

   'settings
   IDM_Debug
   IDM_Test
   IDM_CopyPlus
   IDM_SkipZero
   IDM_GroupIcons
   IDM_Sep
   IDM_ColorLines
   IDM_AutoSearch
   IDM_IncludeHidden
   IDM_UseKB
   IDM_Stretched
   IDM_Centered
   IDM_Transparent
   IDM_ShowCheckBoxes
   IDM_ImpliedSearch
   IDM_SelectCompareApp
   IDM_FileColor
   IDM_DupeColorA
   IDM_DupeColorB
   IDM_BGColor
   IDM_OnlineUpdate

   'hContextFileSpec
   IDM_CutFileSpec
   IDM_CopyFileSpec
   IDM_PasteFileSpec
   IDM_DeleteFileSpec
   IDM_ClearFileSpec

   'hContextLVPaths
   IDM_OpenPath
   IDM_ClearPaths
   IDM_CheckAllPaths
   IDM_UnCheckAllPaths
   IDM_MoveCheckedPaths

   'hContextLVResults
   IDM_CopyList
   IDM_CopySelection
   IDM_CopyChecked
   IDM_OpenLocation
   IDM_ViewSelection
   IDM_OpenGroup

   IDM_ClearList
   IDM_RemoveSelected
   IDM_RemoveChecked

   IDM_CheckAllResults
   IDM_UnCheckAllResults

   IDM_CompareLeft
   IDM_CompareRight
   IDM_Compare

   IDM_DeleteSelected

   IDM_WastedSpace
   IDM_FileProperties
   IDM_Summary

   'misc equates
   AllFiles     'display mode
   DupeFiles    'display mode

   DupeIsName
   DupeIsBytes

   TextFile
   ImageFile
   OtherFile

   'online update
   IDM_CheckForUpdates
   IDC_DownloadLabel
   IDC_ProgressBar
   IDC_InstallOk
   IDC_InstallCancel
   IDC_InstallCheckBox
   IDC_InstallImage
   IDC_InstallLabel

End Enum

Global hDlg, hImageListTB,hImageListGroup, hImageListEmpty, hToolbar, hPopUpSettings, ghHook As Dword
Global hLVResults, hLVPaths, hFont, hFontT, hDebug, hComboFileSpec, hComboFileSpecEdit As Dword
Global hContextFileSpec, hContextLVResults, hContextLVPaths, Token, hWait, hInstall As Dword
Global OldCBFileSpecProc, OldLVProcResults, OldLVProcPaths, ColorLines,UseKB As Long
Global AutoSearch,IncludeHidden, CopyPlus, SkipZero, GroupIcons, InternalViewer,Stretched,Transparent As Long
Global SubFolders, ShowCheckBoxes, DisplayMode, FirstTime, UseDate, DupeMode, DMatched(), Centered As Long
Global FolderCount, FileCount, DFileCount, Debug, SortDirectionPaths, SortDirection, SelectionPaths, SelectionResults As Long
Global FontSize, FontStyle, ImpliedSearch, FileColor, DupeColorA, DupeColorB, BGColor As Long
Global ViewerControlType, SelectedFileType, Restart As Long
Global CompareApp, CompareLeft, CompareRight, FontName, FileSpec, FileStrings(), ValidTextExt, ValidImageExt As String
Global Folders(), Files(), DFiles(), LastSearch() As DirData
Global qFreq, qStart, qStop As Quad, CustomColorList As CustomColors
'Files(0) is not used

Function PBMain() As Long
   Local style&
   style& = %WS_TabStop Or %WS_Border Or  %ES_Left Or %ES_AutoVScroll _
             Or %ES_MultiLine Or %ES_NoHideSel Or %ES_WantReturn Or %WS_VScroll Or %WS_ClipSiblings
   Font New "Tahoma", 8, 0 To hFontT
   Dialog New Pixels, 0, "gbDuplicateFileFinder v" + $ver,300,300,400,200, %WS_OverlappedWindow Or %WS_ClipChildren, 0 To hDlg
   Dialog Set Icon hDlg, "aaa"

   Control Add Label, hDlg, %IDC_Label, "File Spec:", 10,55,50,20
   Control Add ComboBox, hDlg, %IDC_ComboFileSpec, , 65,60,300,160, %CBS_DropDown Or %WS_TabStop Or %WS_VScroll, %WS_Ex_ClientEdge

   Control Add ListView, hDlg, %IDC_LVPaths,"", 10,85,80,120, %WS_TabStop Or %LVS_Report Or %LVS_SingleSel Or %WS_Border Or %LVS_ShowSelAlways, %WS_Ex_Left Or %WS_Ex_ClientEdge
   Control Handle hDlg, %IDC_LVPaths To hLVPaths   'Or %LVS_ShowSelAlways
   ListView Set StyleXX hDlg, %IDC_LVPaths, %LVS_Ex_GridLines Or %LVS_Ex_DoubleBuffer Or %LVS_Ex_FullRowSelect Or %LVS_Ex_CheckBoxes
   ListView Insert Column hDlg, %IDC_LVPaths, 1, "Search Paths", 295,0

   Control Add ListView, hDlg, %IDC_LVResults,"", 10,210,380,100, %WS_TabStop Or %LVS_Report Or %LVS_SingleSel Or %WS_Border Or %LVS_ShowSelAlways, %WS_Ex_Left Or %WS_Ex_ClientEdge
   Control Handle hDlg, %IDC_LVResults To hLVResults
   ListView Insert Column hDlg, %IDC_LVResults, 1, "File Name", 80, 0
   ListView Insert Column hDlg, %IDC_LVResults, 2, "Bytes", 50, 1
   ListView Insert Column hDlg, %IDC_LVResults, 3, "Date", 140, 0
   ListView Insert Column hDlg, %IDC_LVResults, 4, "Full Path", 200, 0
   CreateLVImageLists

   Control Add Statusbar, hDlg, %IDC_StatusBar, "",0,0,0,0
   Dialog Show Modal hDlg Call DlgProc

   If Restart Then
      If IsFile(Exe.Path$ + Exe.Name$ + ".exe.old") Then Kill Exe.Path$ + Exe.Name$ + ".exe.old"
      Name Exe.Path$ + Exe.Name$ + ".exe" As Exe.Path$ + Exe.Name$ + ".exe.old"
      Name Exe.Path$ + Exe.Name$ + ".new" As Exe.Path$ + Exe.Name$ + ".exe"
      Restart = Shell(Exe.Full$,1)
   End If

End Function

CallBack Function DlgProc() As Long
   Local x,y,iResult As Long, result$, temp$, nmtb As TBNotify Ptr
   Local rc As Rect, P As ToolTipText Ptr, lplvcd As NMLVCUSTOMDRAW Ptr, LVData As NM_ListView

   Select Case Cb.Msg
      Case %WM_InitDialog
          ' Initialize GDI+
          Local StartupInput As GdiplusStartupInput
          StartupInput.GdiplusVersion = 1
          GdiplusStartup(Token, StartupInput, ByVal %NULL)

          Settings_INI "get"
          ManageDebug
          QueryPerformanceFrequency qFreq
          Control Set Font hDlg, %IDC_Label, hFontT
          Control Set Font hDlg, %IDC_ComboFileSpec, hFontT
          Control Set Font hDlg, %IDC_Toolbar, hFontT
          BuildAcceleratorTable
          CreateContextMenus : CreateContextResults
          SubClassControls  'combobox and two ListViews
          ListView Set StyleXX hDlg, %IDC_LVResults, %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect Or %LVS_Ex_DoubleBuffer Or IIf(ShowCheckBoxes,%LVS_Ex_CheckBoxes, 0)
          CreateToolbar
          Font New FontName, FontSize, FontStyle To hFont
          Control Set Font hDlg, %IDC_LVPaths, hFont
          Control Set Font hDlg, %IDC_LVResults, hFont
          SetMenusAndToolbarButtons
          ComboBox Select hDlg, %IDC_ComboFileSpec, 1 : PostMessage hComboFileSpecEdit, %EM_SetSel, 0,0
          RestoreSession
          DisplayGroupIcons
          UpdateStatusBar
'          ListView Select hDlg, %IDC_LVResults, IIf(SelectionResults, SelectionResults,1)
          ListView_SetItemState hLVResults, IIf(SelectionResults, SelectionResults-1,0), %LVIS_Focused Or %LVIS_Selected, %LVIS_Focused Or %LVIS_Selected
'          ListView Select hDlg, %IDC_LVPaths, IIf(SelectionPaths, SelectionPaths,1)
          ListView_SetItemState hLVPaths, IIf(SelectionPaths, SelectionPaths-1,0), %LVIS_Focused Or %LVIS_Selected, %LVIS_Focused Or %LVIS_Selected

          If FirstTime Then
             ListView Insert Item hDlg, %IDC_LVPaths, 1,0, Trim$(Exe.Path$,"\")
             ListView_SetCheckState hLVPaths, 0, %True
             FirstTime = 0
          End If

          If InternalViewer Then  LoadSelectedFile(0) Else LoadStatusBar

          ListView Get Count hDlg, %IDC_LVResults To iResult
          If iResult Then
             Control Set Focus hDlg, %IDC_LVResults
          Else
             Control Set Focus hDlg, %IDC_LVPaths
          End If

      Case %WM_Destroy
          Control Get Text hDlg, %IDC_ComboFileSpec To filespec
          ListView Get Select hDlg, %IDC_LVPaths To SelectionPaths
          ListView Get Select hDlg, %IDC_LVResults To SelectionResults
          FileCount = UBound(Files)
          DFileCount = UBound(DFiles)
          Settings_INI "save"
          SaveSession
          SetWindowLong hComboFileSpecEdit, %GWL_WNDPROC, OldCBFileSpecProc  'un-subclass
          SetWindowLong hLVResults        , %GWL_WNDPROC, OldLVProcResults   'un-subclass
          SetWindowLong hLVPaths          , %GWL_WNDPROC, OldLVProcPaths   'un-subclass
          GdiPlusShutDown token
      Case %WM_Command
          Select Case Cb.Ctl
              Case %IDM_CopyPlus  : CopyPlus = CopyPlus Xor 1

              Case %IDM_OnlineUpdate
                 CheckForUpdates($ver)

              Case %IDM_SkipZero
                 SkipZero = SkipZero Xor 1
                 SetMenusAndToolbarButtons

              Case %IDM_GroupIcons
                 GroupIcons = GroupIcons Xor 1
                 SetMenusAndToolbarButtons
                 DisplayGroupIcons

              Case %IDT_FolderNew
                 ListView Get Select hDlg, %IDC_LVPaths To iResult
                 ListView Get Text hDlg, %IDC_LVPaths, iResult, 1 To temp$
                 If Len(temp$) = 0 Then ListView Get Text hDlg, %IDC_LVPaths, 1, 1 To temp$
                 If Len(temp$) = 0 Then temp$ = Exe.Path$
                 SelectFolder temp$

              Case %IDT_FolderDel
                 ListView Get Count hDlg, %IDC_LVPaths To x
                 ListView Get Select hDlg, %IDC_LVPaths To iResult
                 If iResult Then
                    ListView Delete Item hDlg, %IDC_LVPaths, iResult
                    ListView Get Count hDlg, %IDC_LVPaths To x
                    If iResult > x Then iResult = x
'                    ListView Select hDlg, %IDC_LVPaths, iResult
                    ListView_SetItemState hLVPaths, iResult-1, %LVIS_Focused Or %LVIS_Selected, %LVIS_Focused Or %LVIS_Selected  '<--- synchronizing code
                    Control Set Focus hDlg, %IDC_LVPaths
                 Else
                    Beep
                 End If

              Case %IDT_Search, %IdOk
                 ListView Set ImageList hDlg, %IDC_LVResults, hImageListEmpty, %lvsil_small
                 Search
                 BuildLastSearch
                 CreateContextResults
                 Control Set Focus hDlg, %IDC_LVResults
                 'ListView Select hDlg, %IDC_LVResults, 1
                 ListView_SetItemState hLVResults, 0, %LVIS_Focused Or %LVIS_Selected, %LVIS_Focused Or %LVIS_Selected  '<--- synchronizing code
                 If InternalViewer Then LoadSelectedFile(0)

              Case %IDT_Dupes
                 If AutoSearch Then Search : BuildLastSearch

                 ListView Get Count hDlg, %IDC_LVResults To iResult
                 If iResult = 0 Then Beep : Exit Select

                 If DupeMode = %DupeIsName Then
                    FindDuplicatesNames
                    Control Set Focus hDlg, %IDC_LVResults
                    'ListView Select hDlg, %IDC_LVResults, 1
                    ListView_SetItemState hLVResults, 0, %LVIS_Focused Or %LVIS_Selected, %LVIS_Focused Or %LVIS_Selected  '<--- synchronizing code
                 Else
                    FindDuplicatesBinary_new
                    Control Set Focus hDlg, %IDC_LVResults
'                    ListView Select hDlg, %IDC_LVResults, 1
                    ListView_SetItemState hLVResults, 0, %LVIS_Focused Or %LVIS_Selected, %LVIS_Focused Or %LVIS_Selected  '<--- synchronizing code
                 End If
                 DisplayGroupIcons
                 CreateContextResults
                 If InternalViewer Then LoadSelectedFile(0)
                 ListView Fit Header hDlg, %IDC_LVResults, 1

               Case %IDT_Redo
                 RestoreLastSearch
                 LoadListViewWithAllFiles
                 UpdateStatusBar
                 If InternalViewer Then LoadSelectedFile(0)

              Case %IDT_ViewGroup
                 If DisplayMode = %DupeFiles Then
                    ShowGroup
                 Else
                    'view just the one selected item in an external viewer
                    ListView Get Select hDlg, %IDC_LVResults To iResult
                    ListView Get Text hDlg, %IDC_LVResults, iResult, 4 To temp$
                    iResult = ShellExecute(hDlg, $Nul, (temp$), $Nul, $Nul, %SW_ShowNormal)
                 End If

              Case %IDT_Name
                 DupeMode = %DupeIsName
                 SetMenusAndToolbarButtons

              Case %IDT_Bytes
                 DupeMode = %DupeIsBytes
                 SetMenusAndToolbarButtons

              Case %IDT_SubFolders : SubFolders = SubFolders Xor 1

              Case %IDT_Date
                 UseDate = UseDate Xor 1
                 SetMenusAndToolbarButtons

              Case %IDT_InternalViewer
                 InternalViewer = InternalViewer Xor 1
                 SetMenusAndToolbarButtons
                 If InternalViewer Then LoadSelectedFile(0)
                 Dialog ReDraw hDlg
                 ResizeWindow
                 If InternalViewer Then LoadSelectedFile(0)

              Case %IDT_Font  : SelectAppFont

              Case %IDT_Help       :
                   temp$ = "http://www.garybeene.com/sw/gbduplicatefilefinder.htm"
                   iResult = ShellExecute(hDlg, $Nul, (temp$), $Nul, $Nul, %SW_ShowNormal)

               Case %IDM_Debug
                  Debug = Debug Xor 1
                  ManageDebug
                  Control Set Focus hDlg, %IDC_LVResults

               Case %IDM_Test
                  Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Name, %TBState_Enabled
                  Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Bytes, %TBState_Enabled
                  ListView Unselect hDlg, %IDC_LVPaths, 1
                  ListView Unselect hDlg, %IDC_LVResults, 1

              Case %IDM_ColorLines, %IDT_Settings
                  ColorLines = ColorLines Xor 1
                  SetMenusAndToolbarButtons
                  Control ReDraw hDlg, %IDC_LVResults

              Case %IDM_AutoSearch
                  AutoSearch = AutoSearch Xor 1
                  SetMenusAndToolbarButtons

              Case %IDM_IncludeHidden
                  IncludeHidden = IncludeHidden Xor 1
                  SetMenusAndToolbarButtons

              Case %IDM_UseKB
                  UseKB = UseKB Xor 1
                  SetMenusAndToolbarButtons
                  If DisplayMode = %AllFiles Then
                     LoadListViewWithAllFiles
                  Else
                     LoadListViewWithDuplicates
                  End If
                  ResizeWindow

              Case %IDM_Stretched
                  Stretched = Stretched Xor 1
                  SetMenusAndToolbarButtons
                  If InternalViewer Then LoadSelectedFile(0)

              Case %IDM_Centered
                  Centered = Centered Xor 1
                  SetMenusAndToolbarButtons
                  If InternalViewer Then LoadSelectedFile(0)

              Case %IDM_Transparent
                  Transparent = Transparent Xor 1
                  SetmenusAndToolbarButtons
                  If InternalViewer Then LoadSelectedFile(0)

              Case %IDM_ShowCheckBoxes, %IDT_Settings
                  ShowCheckBoxes = ShowCheckBoxes Xor 1
                  SetMenusAndToolbarButtons
                  CreateContextResults
                  ListView Set StyleXX hDlg, %IDC_LVResults, %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect Or %LVS_Ex_DoubleBuffer Or IIf(ShowCheckBoxes,%LVS_Ex_CheckBoxes, 0)
                  ResizeWindow

              Case %IDM_ImpliedSearch
                 ImpliedSearch = ImpliedSearch Xor 1
                 SetMenusAndToolbarButtons

              Case %IDM_SelectCompareApp  : SelectCompareApp
              Case %IDM_FileColor         : FileColor = SelectColor(FileColor)
              Case %IDM_DupeColorA        : DupeColorA = SelectColor(DupeColorA)
              Case %IDM_DupeColorB        : DupeColorB = SelectColor(DupeColorB)
              Case %IDM_BGColor
                 BGColor = SelectColor(BGColor)
                 If InternalViewer Then LoadSelectedFile(0)


              Case %IDM_CutFileSpec     : SendMessage hComboFileSpec, %WM_CUT, 0, 0
              Case %IDM_CopyFileSpec    : SendMessage hComboFileSpec, %WM_COPY, 0, 0
              Case %IDM_PasteFileSpec   : SendMessage hComboFileSpec, %WM_PASTE, 0, 0
              Case %IDM_DeleteFileSpec  : SendMessage hComboFileSpec, %WM_CLEAR, 0, 0
              Case %IDM_ClearFileSpec   : ComboBox Reset hDlg, %IDC_ComboFileSpec

              Case %IDM_OpenPath
                 ListView Get Select hDlg, %IDC_LVPaths To iResult
                 ListView Get Text hDlg, %IDC_LVPaths, iResult, 1 To temp$
                 iResult = ShellExecute(hDlg, $Nul, (temp$), $Nul, $Nul, %SW_ShowNormal)

              Case %IDM_ClearPaths       : ListView Reset hDlg, %IDC_LVPaths
              Case %IDM_CheckAllPaths    : CheckAllPaths(1)
              Case %IDM_UnCheckAllPaths  : CheckAllPaths(0)
              Case %IDM_MoveCheckedPaths : MoveCheckedPathsToTop

              Case %IDM_CopyList
                  ListView Get Count hDlg, %IDC_LVResults To iResult
                  For x = 1 To iResult
                      ListView Get Text hDlg, %IDC_LVResults, x,4 To temp$
                      result$ = result$ + $CrLf + temp$
                  Next x
                  Clipboard Reset
                  Clipboard Set Text Trim$(result$,$CrLf) + IIf$(CopyPlus,$CrLf,"")

              Case %IDM_CopySelection
                 ListView Get Select hDlg, %IDC_LVResults To iResult
                 If iResult Then
                    ListView Get Text hDlg, %IDC_LVResults, iResult,4 To temp$
                    Clipboard Reset
                    Clipboard Set Text temp$ + IIf$(CopyPlus,$CrLf,"")
                 End If

              Case %IDM_CopyChecked
                  ListView Get Count hDlg, %IDC_LVResults To iResult
                  For x = 1 To iResult
                      If ListView_GetCheckState(hLVResults,x-1) Then
                         ListView Get Text hDlg, %IDC_LVResults, x,4 To temp$
                         result$ = result$ + $CrLf + temp$
                      End If
                  Next x
                  Clipboard Reset
                  Clipboard Set Text Trim$(result$,$CrLf) + IIf$(CopyPlus,$CrLf,"")

              Case %IDM_OpenLocation
                  ListView Get Select hDlg, %IDC_LVResults To iResult
                  ListView Get Text hDlg, %IDC_LVResults, iResult, 4 To temp$
                  temp$ = PathName$(Path,temp$)
                  iResult = ShellExecute(hDlg, $Nul, (temp$), $Nul, $Nul, %SW_ShowNormal)

              Case %IDM_ViewSelection
                 ListView Get Select hDlg, %IDC_LVResults To iResult
                 ListView Get Text hDlg, %IDC_LVResults, iResult, 4 To temp$
                 iResult = ShellExecute(hDlg, $Nul, (temp$), $Nul, $Nul, %SW_ShowNormal)

              Case %IDM_OpenGroup : ShowGroup

               Case %IDM_ClearList
                 FileCount = 0
                 ReDim Files(0), DFiles(0), DMatched(0)
                 ListView Reset hDlg, %IDC_LVResults : ResizeWindow

              Case %IDM_RemoveSelected, %IDT_Remove : RemoveSelected : If InternalViewer Then LoadSelectedFile(0)
              Case %IDM_DeleteSelected : DeleteSelected : If InternalViewer Then LoadSelectedFile(0)
              Case %IDM_RemoveChecked  : RemoveChecked : If InternalViewer Then LoadSelectedFile(0)

              Case %IDM_CheckAllResults    : CheckAllResults(1)
              Case %IDM_UnCheckAllResults  : CheckAllResults(0)

              Case %IDM_CompareLeft
                 ListView Get Select hDlg, %IDC_LVResults To iResult
                 If iResult Then ListView Get Text hDlg, %IDC_LVResults, iResult, 4 To CompareLeft

              Case %IDM_CompareRight
                 ListView Get Select hDlg, %IDC_LVResults To iResult
                 If iResult Then ListView Get Text hDlg, %IDC_LVResults, iResult, 4 To CompareRight

              Case %IDM_Compare
                 If IsFile(CompareApp) Then
                    iResult = Shell( CompareApp + $Spc + CompareLeft + $Spc + CompareRight)
                 Else
                   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(MsgProc), GetModuleHandle(""), GetCurrentThreadId)
                   MessageBox(0, "Compare Application Not Found!", "External Comparison", %MB_Ok + %MB_IconExclamation)
                 End If

             Case %IDM_WastedSpace    : WastedSpace
             Case %IDM_FileProperties : DisplayFileProperties
             Case %IDM_Summary        : DisplaySummary

          End Select

       Case %WM_Size
           ResizeWindow

       Case %WM_User + 500
           'ResizeColumns(Cb.WParam)
           'ResizeWindow

      Case %WM_Notify
           nmtb = Cb.LParam
           Select Case @nmtb.hdr.Code
              Case %TBN_DROPDOWN
                 Select Case @nmtb.iItem
                    Case %IDT_Settings
                       Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                       Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                       Call TrackPopupMenu (hPopUpSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                 End Select
           End Select

           Select Case Cb.NmId
               Case %IDT_FolderNew To %IDT_Help
                  Select Case Cb.NmCode
                     Case %TTN_GetDispInfo
                         P = Cb.LParam
                         @P.@lpszText = SetToolTips(Cb.NmId)
                  End Select
               Case %IDC_LVPaths
                   Select Case Cb.NmCode
                       Case %NM_DblClk
                           ListView Get Select hDlg, %IDC_LVPaths To iResult
                           ListView Get Text hDlg, %IDC_LVPaths, iResult, 1 To temp$
                           iResult = ShellExecute(hDlg, $Nul, (temp$), $Nul, $Nul, %SW_ShowNormal)
                       Case %LVN_ColumnClick
                           ListView Get Count hDlg, %IDC_LVPaths To iResult
                           If iResult = 0 Then Beep : Exit Select
                           SortDirectionPaths = SortDirectionPaths Xor 1
                           SortPaths
                   End Select
               Case %IDC_LVResults
                   Select Case Cb.NmCode
'                       Case %NM_Click
'                           If InternalViewer Then LoadSelectedFile(0)
                       Case %LVN_ItemChanged
                           ListView Get Select hDlg, %IDC_LVResults To iResult
                           If iResult Then
                              If InternalViewer Then
                                 LoadSelectedFile(0)
                              Else
                                 LoadStatusBar
                              End If
                           End If
                       Case %LVN_ColumnClick
                           ListView Get Count hDlg, %IDC_LVResults To iResult
                           If iResult = 0 Then Beep : Exit Select
                           If DisplayMode = %DupeFiles Then
                              Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Sorting not supported when duplicates are listed!"
                              Beep
                              Exit Select
                           End If
                           MousePtr 11
                           SendMessage GetDlgItem(hDlg,%IDC_LVResults), %WM_SetRedraw, %False, 0
                           SortDirection = SortDirection Xor 1
                           Type Set LVData = Cb.NmHdr$(SizeOf(LVData))
                           Select Case LVData.iSubItem+1
                               Case 1
                                  If SortDirection = 1 Then Array Sort Files(1) For UBound(Files), Call SortByNameA()
                                  If SortDirection = 0 Then Array Sort Files(1) For UBound(Files), Call SortByNameD()
                               Case 2
                                  If SortDirection = 1 Then Array Sort Files(1) For UBound(Files), Call SortBySizeA()
                                  If SortDirection = 0 Then Array Sort Files(1) For UBound(Files), Call SortBySizeD()
                               Case 3
                                  If SortDirection = 1 Then Array Sort Files(1) For UBound(Files), Call SortByDateA()
                                  If SortDirection = 0 Then Array Sort Files(1) For UBound(Files), Call SortByDateD()
                               Case 4
                                  If SortDirection = 1 Then Array Sort Files(1) For UBound(Files), Call SortByPathA()
                                  If SortDirection = 0 Then Array Sort Files(1) For UBound(Files), Call SortByPathD()
                           End Select
                           LoadListViewWithAllFiles
                           SendMessage GetDlgItem(hDlg,%IDC_LVResults), %WM_SetRedraw, %True, 0
                           MousePtr 1
                       Case %NM_DblClk
                           ListView Get Select hDlg, %IDC_LVResults To iResult
                           ListView Get Text hDlg, %IDC_LVResults, iResult, 4 To temp$
                           iResult = ShellExecute(hDlg, $Nul, (temp$), $Nul, $Nul, %SW_ShowNormal)
                       Case %NM_CustomDraw
                           If ColorLines Then
                               lplvcd = Cb.LParam
                               Select Case @lplvcd.nmcd.dwDrawStage
                                   Case %CDDS_PrePaint
                                       Function = %CDRF_NOTIFYITEMDRAW : Exit Function
                                   Case %CDDS_ItemPrePaint
                                       If DisplayMode = %AllFiles Then
                                           Select Case @lplvcd.nmcd.dwItemSpec Mod 6
                                               Case 3,4,5
                                                   @lplvcd.clrTextBk = FileColor  'item BG color
                                           End Select
                                       Else
                                           If DMatched(@lplvcd.nmcd.dwItemSpec+1) Then
                                              @lplvcd.clrTextBk = DupeColorA  'item BG color
                                           Else
                                              @lplvcd.clrTextBk = DupeColorB  'item BG color
                                           End If
                                       End If
                                       Function = %CDRF_NEWFONT : Exit Function   'change item/subitem BG colors
                               End Select
                           End If
                 End Select
           End Select

      Case %WM_ContextMenu
         x = Lo(Integer,Cb.LParam) : y = Hi(Integer, Cb.LParam)    'WM_ContextMenu returns xy coordinates of mouse
         CreateContextResults
         TrackPopupMenu IIf(GetFocus = hLVResults, hContextLVResults, hContextLVPaths), %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
    End Select
End Function

Sub SelectFolder(sFolder$)
   If Debug Then Txt.Print FuncName$
   Local title$, start$, flags&, folder$, i,iCount As Long, temp$
   title$ = "Select Path to Add to List"
   start$ = sFolder$
   flags& = %BIF_ReturnOnlyFSDirs Or %BIF_DontGoBelowDomain Or %BIF_NoNewFolderButton
   Display Browse  hDlg, 100, 100, title$, start$, flags& To folder$   'folder$ is set to "" if Cancel/Escape is pressed
   If Len(folder$) Then
      folder$ = Trim$(folder$,"\")
      flags& = 0
      ListView Get Count hDlg, %IDC_LVPaths To iCount
      For i = 1 To iCount
         ListView Get Text hDlg, %IDC_LVPaths, i, 1 To temp$
         If temp$ = folder$ Then flags& = 1 : Exit For
      Next i
      If flags& = 0 Then
         ListView Insert Item hDlg, %IDC_LVPaths, 1, 0, folder$
         ListView_SetCheckState hLVPaths, 0, %True
      Else
         ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(MsgProc), GetModuleHandle(""), GetCurrentThreadId)
         MessageBox(0, "Search path already in list!", "Add New Path", %MB_Ok + %MB_IconExclamation)
      End If
   End If
End Sub

Sub Settings_INI(Task$)
   If Debug Then Txt.Print FuncName$
   Local i,x,y As Long, xResult, yResult, tempz, INIFileName As WStringZ * %Max_Path, temp$
   'set ini filename
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "400", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "400", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top
      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "710", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "600", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height
      'get value for string variables
      Getprivateprofilestring "All", "ValidTextExt", ".txt .bas .inc .htm", tempz, %Max_Path, INIFileName : ValidTextExt = tempz
      Getprivateprofilestring "All", "ValidImageExt", ".bmp .ico .jpg .gif .png", tempz, %Max_Path, INIFileName : ValidImageExt = tempz
      Getprivateprofilestring "All", "CompareLeft", "", tempz, %Max_Path, INIFileName : CompareLeft = tempz
      Getprivateprofilestring "All", "CompareRight", "", tempz, %Max_Path, INIFileName : CompareRight = tempz
      Getprivateprofilestring "All", "CompareApp", "", tempz, %Max_Path, INIFileName : CompareApp = tempz
      Getprivateprofilestring "All", "FontName", "Tahoma", tempz, %Max_Path, INIFileName : FontName = tempz
      GetPrivateProfileString "All", "FileSpec1", "*.txt", tempz, %Max_Path, INIFileName
      temp$ = tempz : ComboBox Add hDlg, %IDC_ComboFileSpec, temp$
      GetPrivateProfileString "All", "FileSpec2", "*.bas", tempz, %Max_Path, INIFileName
      temp$ = tempz : ComboBox Add hDlg, %IDC_ComboFileSpec, temp$
      GetPrivateProfileString "All", "FileSpec3", "*.txt;*.bas;*.inc;*.htm", tempz, %Max_Path, INIFileName
      temp$ = tempz : ComboBox Add hDlg, %IDC_ComboFileSpec, temp$
      GetPrivateProfileString "All", "FileSpec4", "*.jpg;*.gif;*.bmp;*.png;*.ico", tempz, %Max_Path, INIFileName
      temp$ = tempz : ComboBox Add hDlg, %IDC_ComboFileSpec, temp$
      GetPrivateProfileString "All", "FileSpec5", "*.*", tempz, %Max_Path, INIFileName
      temp$ = tempz : ComboBox Add hDlg, %IDC_ComboFileSpec, temp$

      'get value for numeric variables
      Getprivateprofilestring "All", "FirstTime", "1", tempz, %Max_Path, INIFileName :    FirstTime = Val(tempz)
      Getprivateprofilestring "All", "SelectionResults", "1", tempz, %Max_Path, INIFileName :    SelectionResults = Val(tempz)
      Getprivateprofilestring "All", "SelectionPaths", "1", tempz, %Max_Path, INIFileName :    SelectionPaths = Val(tempz)
      Getprivateprofilestring "All", "DisplayMode", Str$(%AllFiles), tempz, %Max_Path, INIFileName :    DisplayMode = Val(tempz)
      Getprivateprofilestring "All", "DupeMode", Str$(%DupeIsName), tempz, %Max_Path, INIFileName :    DupeMode = Val(tempz)
      Getprivateprofilestring "All", "UseDate", "0", tempz, %Max_Path, INIFileName :    UseDate = Val(tempz)
      Getprivateprofilestring "All", "FontStyle", "0", tempz, %Max_Path, INIFileName:   FontStyle = Val(tempz)
      Getprivateprofilestring "All", "FontSize", "8", tempz, %Max_Path, INIFileName :   FontSize = Val(tempz)
      Getprivateprofilestring "All", "FileCount", "0", tempz, %Max_Path, INIFileName:   FileCount = Val(tempz)
      Getprivateprofilestring "All", "DFileCount", "0", tempz, %Max_Path, INIFileName:   DFileCount = Val(tempz)
      Getprivateprofilestring "All", "DupeColorA", Str$(RGB(215,254,214)), tempz, %Max_Path, INIFileName :  DupeColorA = Val(tempz)
      Getprivateprofilestring "All", "DupeColorB", Str$(RGB(214,225,254)), tempz, %Max_Path, INIFileName :  DupeColorB = Val(tempz)
      Getprivateprofilestring "All", "FileColor", Str$(RGB(235,235,235)), tempz, %Max_Path, INIFileName : FileColor = Val(tempz)
      Getprivateprofilestring "All", "ColorLines", "1", tempz, %Max_Path, INIFileName : ColorLines = Val(tempz)
      Getprivateprofilestring "All", "AutoSearch", "0", tempz, %Max_Path, INIFileName : AutoSearch = Val(tempz)
      Getprivateprofilestring "All", "IncludeHidden", "0", tempz, %Max_Path, INIFileName : IncludeHidden = Val(tempz)
      Getprivateprofilestring "All", "UseKB", "0", tempz, %Max_Path, INIFileName : UseKB = Val(tempz)
      Getprivateprofilestring "All", "Stretched", "0", tempz, %Max_Path, INIFileName : Stretched = Val(tempz)
      Getprivateprofilestring "All", "Centered", "0", tempz, %Max_Path, INIFileName : Centered = Val(tempz)
      Getprivateprofilestring "All", "Transparent", "0", tempz, %Max_Path, INIFileName : Transparent = Val(tempz)
      Getprivateprofilestring "All", "BGColor", Str$(%White), tempz, %Max_Path, INIFileName : BGColor = Val(tempz)
      Getprivateprofilestring "All", "ShowCheckBoxes", "0", tempz, %Max_Path, INIFileName : ShowCheckBoxes = Val(tempz)
      Getprivateprofilestring "All", "SubFolders", "1", tempz, %Max_Path, INIFileName : SubFolders = Val(tempz)
      Getprivateprofilestring "All", "ImpliedSearch", "0", tempz, %Max_Path, INIFileName : ImpliedSearch = Val(tempz)
      Getprivateprofilestring "All", "SortDirection", "0", tempz, %Max_Path, INIFileName : SortDirection = Val(tempz)
      Getprivateprofilestring "All", "SortDirectionPaths", "0", tempz, %Max_Path, INIFileName : SortDirectionPaths = Val(tempz)
      Getprivateprofilestring "All", "CopyPlus", "0", tempz, %Max_Path, INIFileName : CopyPlus = Val(tempz)
      Getprivateprofilestring "All", "SkipZero", "0", tempz, %Max_Path, INIFileName : SkipZero = Val(tempz)
      Getprivateprofilestring "All", "GroupIcons", "1", tempz, %Max_Path, INIFileName : GroupIcons = Val(tempz)
      Getprivateprofilestring "All", "InternalViewer", "0", tempz, %Max_Path, INIFileName : InternalViewer = Val(tempz)
      For x = 0 To 15
         Getprivateprofilestring "Custom", "CustomColor" + Format$(x,"00"), "", tempz, %Max_Path, INIFileName
         CustomColorList.c(x) = Val(tempz)
      Next
   End If

   If Task$ = "save" Then
      If Len(Dir$(INIFileName)) Then Kill INIFileName
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      Dialog Get Client hDlg To x,y
      'save string variables
      WritePrivateProfileString "All", "ValidTextExt",(ValidTextExt), INIFileName
      WritePrivateProfileString "All", "ValidImageExt",(ValidImageExt), INIFileName
      WritePrivateProfileString "All", "CompareLeft",(CompareLeft), INIFileName
      WritePrivateProfileString "All", "CompareRight",(CompareRight), INIFileName
      WritePrivateProfileString "All", "CompareApp",(CompareApp), INIFileName
      WritePrivateProfileString "All", "FontName",(FontName), INIFileName
      For i = 1 To 5
          ComboBox Get Text hDlg, %IDC_ComboFileSpec, i To temp$
          WritePrivateProfileString "All", "FileSpec" + Trim$(Str$(i)),(temp$), INIFileName
      Next i
      'save numeric variables
      WritePrivateProfileString "All", "FirstTime", (Str$(FirstTime)), INIFileName
      WritePrivateProfileString "All", "SelectionResults", (Str$(SelectionResults)), INIFileName
      WritePrivateProfileString "All", "SelectionPaths", (Str$(SelectionPaths)), INIFileName
      WritePrivateProfileString "All", "DisplayMode", (Str$(DisplayMode)), INIFileName
      WritePrivateProfileString "All", "DupeMode", (Str$(DupeMode)), INIFileName
      WritePrivateProfileString "All", "UseDate", (Str$(UseDate)), INIFileName
      WritePrivateProfileString "All", "FontStyle", (Str$(FontStyle)), INIFileName
      WritePrivateProfileString "All", "FontSize", (Str$(FontSize)), INIFileName
      WritePrivateProfileString "All", "FileCount", (Str$(Max(FileCount,0))), INIFileName
      WritePrivateProfileString "All", "DFileCount", (Str$(Max(DFileCount,0))), INIFileName
      WritePrivateProfileString "All", "DupeColorA", (Str$(DupeColorA)), INIFileName
      WritePrivateProfileString "All", "DupeColorB", (Str$(DupeColorB)), INIFileName
      WritePrivateProfileString "All", "FileColor", (Str$(FileColor)), INIFileName
      WritePrivateProfileString "All", "ColorLines", (Str$(ColorLines)), INIFileName
      WritePrivateProfileString "All", "AutoSearch", (Str$(AutoSearch)), INIFileName
      WritePrivateProfileString "All", "IncludeHidden", (Str$(IncludeHidden)), INIFileName
      WritePrivateProfileString "All", "UseKB", (Str$(UseKB)), INIFileName
      WritePrivateProfileString "All", "Stretched", (Str$(Stretched)), INIFileName
      WritePrivateProfileString "All", "Centered", (Str$(Centered)), INIFileName
      WritePrivateProfileString "All", "Transparent", (Str$(Transparent)), INIFileName
      WritePrivateProfileString "All", "BGColor", (Str$(BGColor)), INIFileName
      WritePrivateProfileString "All", "ShowCheckBoxes", (Str$(ShowCheckBoxes)), INIFileName
      WritePrivateProfileString "All", "SubFolders", (Str$(SubFolders)), INIFileName
      WritePrivateProfileString "All", "ImpliedSearch", (Str$(ImpliedSearch)), INIFileName
      WritePrivateProfileString "All", "SortDirection", (Str$(SortDirection)), INIFileName
      WritePrivateProfileString "All", "SortDirectionPaths", (Str$(SortDirectionPaths)), INIFileName
      WritePrivateProfileString "All", "CopyPlus", (Str$(CopyPlus)), INIFileName
      WritePrivateProfileString "All", "SkipZero", (Str$(SkipZero)), INIFileName
      WritePrivateProfileString "All", "GroupIcons", (Str$(GroupIcons)), INIFileName
      WritePrivateProfileString "All", "InternalViewer", (Str$(InternalViewer)), INIFileName
      For x = 0 To 15
         tempz = Str$(CustomColorList.c(x))
         WritePrivateProfileString "Custom", "CustomColor" + Format$(x,"00"), tempz, INIFileName
      Next
   End If
End Sub

Sub CreateLVImageLists

    ImageList New Icon 1,16,24,1 To hImageListEmpty
    'no images

    ImageList New Icon 16,16,24,3 To hImageListGroup
    ImageList Add Icon hImageListGroup, "xtop"      '1
    ImageList Add Icon hImageListGroup, "xmid"      '2
    ImageList Add Icon hImageListGroup, "xbottom"   '3
End Sub

Sub CreateToolbar
    If Debug Then Txt.Print FuncName$

    ImageList New Icon 24,24,24,20 To hImageListTB
    ImageList Add Icon hImageListTB, "xfolder"      '1
    ImageList Add Icon hImageListTB, "xsearch"      '2
    ImageList Add Icon hImageListTB, "xdupes"       '3
    ImageList Add Icon hImageListTB, "xsubfolders"  '4
    ImageList Add Icon hImageListTB, "xsettings"    '5
    ImageList Add Icon hImageListTB, "xhelp"        '6
    ImageList Add Icon hImageListTB, "xname"        '7
    ImageList Add Icon hImageListTB, "xbytes"       '8
    ImageList Add Icon hImageListTB, "xdate"        '9
    ImageList Add Icon hImageListTB, "xfont"        '10
    ImageList Add Icon hImageListTB, "xadd"         '11
    ImageList Add Icon hImageListTB, "xdelete"      '12
    ImageList Add Icon hImageListTB, "xredo"        '13
    ImageList Add Icon hImageListTB, "xremove"      '14
    ImageList Add Icon hImageListTB, "xviewer"      '15
    ImageList Add Icon hImageListTB, "xinternal"    '16

    Menu New PopUp To hPopupSettings
    Menu Add String, hPopupSettings, "Line Colors", %IDM_ColorLines, %MF_Enabled
    Menu Add String, hPopupSettings, "CheckBoxes", %IDM_ShowCheckBoxes, %MF_Enabled
    Menu Add String, hPopupSettings, "Group Icons", %IDM_GroupIcons, %MF_Enabled
    Menu Add String, hPopupSettings, "Size as KB", %IDM_UseKB, %MF_Enabled
    Menu Add String, hPopupSettings, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupSettings, "Hidden/System Files", %IDM_IncludeHidden, %MF_Enabled
    Menu Add String, hPopupSettings, "Implied Search", %IDM_ImpliedSearch, %MF_Enabled
    Menu Add String, hPopupSettings, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupSettings, "AutoSearch", %IDM_AutoSearch, %MF_Enabled
    Menu Add String, hPopupSettings, "Skip Zero Size", %IDM_SkipZero, %MF_Enabled
    Menu Add String, hPopupSettings, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupSettings, "Stretch Mode", %IDM_Stretched, %MF_Enabled
    Menu Add String, hPopupSettings, "Transparent Image Background", %IDM_Transparent, %MF_Enabled
    Menu Add String, hPopupSettings, "Center Image", %IDM_Centered, %MF_Enabled
    Menu Add String, hPopupSettings, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupSettings, "Select Comparison Application",  %IDM_SelectCompareApp,  %MF_Enabled
    Menu Add String, hPopupSettings, "Select Alternating Line Color",  %IDM_FileColor,  %MF_Enabled
    Menu Add String, hPopupSettings, "Select Duplicate Color A",  %IDM_DupeColorA,  %MF_Enabled
    Menu Add String, hPopupSettings, "Select Duplicate Color B",  %IDM_DupeColorB,  %MF_Enabled
    Menu Add String, hPopupSettings, "Select Image Background Color",  %IDM_BGColor,  %MF_Enabled
    Menu Add String, hPopupSettings, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupSettings, "Online Update",  %IDM_OnlineUpdate,  %MF_Enabled



    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS
    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageListTB, 0    'attach imagelist
    Toolbar Add Button  hDlg, %IDC_Toolbar, 11, %IDT_FolderNew,  %TbStyle_Button, "New"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 12, %IDT_FolderDel,  %TbStyle_Button, "Remove"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 10
    Toolbar Add Button  hDlg, %IDC_Toolbar, 2, %IDT_Search,  %TbStyle_Button, "Search"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 3, %IDT_Dupes,  %TbStyle_Button, "Dupes"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 13, %IDT_Redo,  %TbStyle_Button, "Restore"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 10
    Toolbar Add Button  hDlg, %IDC_Toolbar, 14, %IDT_Remove,  %TbStyle_Button, "Remove"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 15, %IDT_ViewGroup,  %TbStyle_Button, "View"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 10
    Toolbar Add Button  hDlg, %IDC_Toolbar, 7, %IDT_Name,  %TbStyle_CheckGroup, "Name"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 8, %IDT_Bytes,  %TbStyle_CheckGroup, "Bytes"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 10
    Toolbar Add Button  hDlg, %IDC_Toolbar, 4, %IDT_SubFolders,  %TbStyle_Check, "SubFolders"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 9, %IDT_Date,  %TbStyle_Check, "Date"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 16, %IDT_InternalViewer,  %TbStyle_Button, "Viewer"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 10, %IDT_Font,  %TbStyle_Button, "Font"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 5, %IDT_Settings,  %TbStyle_Button Or %TbStyle_DropDown, "Settings"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 6, %IDT_Help,  %TbStyle_Button, "Help"
End Sub

Sub SetMenusAndToolbarButtons
   If Debug Then Txt.Print FuncName$
   'Controls
   Control Show State hDlg, %IDC_Viewer, IIf(InternalViewer, %SW_Show, %SW_Hide)

   'Toolbar Buttons
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_InternalViewer, %TBState_Checked * InternalViewer Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_SubFolders, %TBState_Checked * SubFolders Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Date, %TBState_Checked * UseDate Or %TBState_Enabled
   Select Case DupeMode
      Case %DupeIsName  : Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Name, %TBState_Checked Or %TBState_Enabled
      Case %DupeIsBytes : Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Bytes, %TBState_Checked Or %TBState_Enabled
   End Select

   'Menus
   Menu Set State hPopupSettings, ByCmd %IDM_ColorLines, ColorLines * %MFS_Checked
   Menu Set State hPopupSettings, ByCmd %IDM_AutoSearch, AutoSearch * %MFS_Checked
   Menu Set State hPopupSettings, ByCmd %IDM_IncludeHidden, IncludeHidden * %MFS_Checked
   Menu Set State hPopupSettings, ByCmd %IDM_UseKB, UseKB * %MFS_Checked
   Menu Set State hPopupSettings, ByCmd %IDM_Stretched, Stretched * %MFS_Checked
   Menu Set State hPopupSettings, ByCmd %IDM_Centered, Centered * %MFS_Checked
   Menu Set State hPopupSettings, ByCmd %IDM_Transparent, Transparent * %MFS_Checked
   Menu Set State hPopupSettings, ByCmd %IDM_ShowCheckBoxes, ShowCheckBoxes * %MFS_Checked
   Menu Set State hPopupSettings, ByCmd %IDM_GroupIcons, GroupIcons * %MFS_Checked
   Menu Set State hPopupSettings, ByCmd %IDM_ImpliedSearch, ImpliedSearch * %MFS_Checked
   Menu Set State hPopupSettings, ByCmd %IDM_SkipZero, SkipZero * %MFS_Checked

   'Controls
   ListView Set Header hDlg, %IDC_LVResults, 2, IIf$(UseKB,"KB","Bytes")
End Sub

Sub SubClassControls
   If Debug Then Txt.Print FuncName$
   Local ComboInfo As ComboBoxInfo
   Control Handle hDlg, %IDC_ComboFileSpec To hComboFileSpec
   ComboInfo.cbSize = SizeOf(ComboBoxInfo)
   GetComboBoxInfo(GetDlgItem(hDlg,%IDC_ComboFileSpec), ByVal VarPtr(ComboInfo))          'get data about combobox
   hComboFileSpecEdit = ComboInfo.hwndItem                           'handle to edit control of combobox
   OldCBFileSpecProc = SetWindowLong(hComboFileSpecEdit, %GWL_WndProc, CodePtr(NewCBFileSpecProc))   'subclass a control

   OldLVProcResults = SetWindowLong(hLVResults, %GWL_WndProc, CodePtr(NewLVProcResults))  'subclass
   OldLVProcPaths = SetWindowLong(hLVPaths, %GWL_WndProc, CodePtr(NewLVProcPaths))  'subclass
End Sub

Function NewLVProcResults(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local hdnptr As HD_NOTIFY Ptr, hdiptr As HD_ITEM Ptr, iResult As Long
   Select Case Msg
      Case %WM_Notify
         hdnptr = lParam
         hdiptr = @hdnptr.pitem
         Select Case @hdnptr.hdr.code
            Case %hdn_EndTrackW
                iResult = @hdnptr.iItem
                Dialog Post hDlg, %WM_User+500, iResult, 0
         End Select
   End Select
   Function = CallWindowProc(OldLVProcResults, hWnd, Msg, wParam, lParam)
End Function

Function NewLVProcPaths(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local hdnptr As HD_NOTIFY Ptr, hdiptr As HD_ITEM Ptr, iResult As Long
   Select Case Msg
      Case %WM_Notify
         hdnptr = lParam
         hdiptr = @hdnptr.pitem
         Select Case @hdnptr.hdr.code
            Case %hdn_EndTrackW
                iResult = @hdnptr.iItem
                Dialog Post hDlg, %WM_User+500, iResult, 0
         End Select
   End Select
   Function = CallWindowProc(OldLVProcPaths, hWnd, Msg, wParam, lParam)
End Function

Function NewCBFileSpecProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long
   Select Case Msg
      Case %WM_ContextMenu
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContextFileSpec, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldCBFileSPecProc, hWnd, Msg, wParam, lParam)
End Function

Sub CreateContextResults
   If Debug Then Txt.Print FuncName$

   DestroyMenu hContextLVResults
   Menu New PopUp To hContextLVResults

   Menu Add String, hContextLVResults, "Copy Entire List",  %IDM_CopyList,  %MF_Enabled
   Menu Add String, hContextLVResults, "Copy Selected Item",  %IDM_CopySelection,  %MF_Enabled
If ShowCheckBoxes Then Menu Add String, hContextLVResults, "Copy Checked Items",  %IDM_CopyChecked,  %MF_Enabled

   Menu Add String, hContextLVResults, "-",  %IDM_Sep,  %MF_Enabled
   Menu Add String, hContextLVResults, "Open Selected Item",  %IDM_ViewSelection,  %MF_Enabled
   Menu Add String, hContextLVResults, "Open Selected Item Location",  %IDM_OpenLocation,  %MF_Enabled
If DisplayMode = %DupeFiles Then   Menu Add String, hContextLVResults, "Open Group",  %IDM_OpenGroup,  %MF_Enabled

   Menu Add String, hContextLVResults, "-",  %IDM_Sep,  %MF_Enabled
   Menu Add String, hContextLVResults, "Remove All Items From List",  %IDM_ClearList,  %MF_Enabled
   Menu Add String, hContextLVResults, "Remove Selected Item From List",  %IDM_RemoveSelected,  %MF_Enabled

If ShowCheckBoxes Then
   Menu Add String, hContextLVResults, "Remove Checked Item(s) From List",  %IDM_RemoveChecked,  %MF_Enabled
   Menu Add String, hContextLVResults, "-",  %IDM_Sep,  %MF_Enabled
   Menu Add String, hContextLVResults, "Check All",  %IDM_CheckAllResults,  %MF_Enabled
   Menu Add String, hContextLVResults, "UnCheck All",  %IDM_UnCheckAllResults,  %MF_Enabled
End If

   Menu Add String, hContextLVResults, "-",  %IDM_Sep,  %MF_Enabled
   Menu Add String, hContextLVResults, "Set Compare Left",  %IDM_CompareLeft,  %MF_Enabled
   Menu Add String, hContextLVResults, "Set Compare Right",  %IDM_CompareRight,  %MF_Enabled
   Menu Add String, hContextLVResults, "Compare Externally",  %IDM_Compare,  %MF_Enabled
   Menu Add String, hContextLVResults, "-",  %IDM_Sep,  %MF_Enabled

   Menu Add String, hContextLVResults, "Delete Selected File From PC",  %IDM_DeleteSelected,  %MF_Enabled
   Menu Add String, hContextLVResults, "-",  %IDM_Sep,  %MF_Enabled
If DisplayMode = %DupeFiles Then   Menu Add String, hContextLVResults, "Wasted Space",  %IDM_WastedSpace,  %MF_Enabled
   Menu Add String, hContextLVResults, "Display Selected File Properties",  %IDM_FileProperties,  %MF_Enabled
   Menu Add String, hContextLVResults, "Display Summary",  %IDM_Summary,  %MF_Enabled
End Sub

Sub CreateContextMenus
   If Debug Then Txt.Print FuncName$

   Menu New PopUp To hContextLVPaths
   Menu Add String, hContextLVPaths, "Open Path",  %IDM_OpenPath,  %MF_Enabled
   Menu Add String, hContextLVPaths, "-",  %IDM_Sep,  %MF_Enabled
   Menu Add String, hContextLVPaths, "Clear List",  %IDM_ClearPaths,  %MF_Enabled
   Menu Add String, hContextLVPaths, "-",  %IDM_Sep,  %MF_Enabled
   Menu Add String, hContextLVPaths, "Check All",  %IDM_CheckAllPaths,  %MF_Enabled
   Menu Add String, hContextLVPaths, "UnCheck All",  %IDM_UnCheckAllPaths,  %MF_Enabled
   Menu Add String, hContextLVPaths, "-",  %IDM_Sep,  %MF_Enabled
   Menu Add String, hContextLVPaths, "Move Checked Paths to Top",  %IDM_MoveCheckedPaths,  %MF_Enabled

   Menu New PopUp To hContextFileSpec
   Menu Add String, hContextFileSpec, "Cut",  %IDM_CutFileSpec,  %MF_Enabled
   Menu Add String, hContextFileSpec, "Copy",  %IDM_CopyFileSpec,  %MF_Enabled
   Menu Add String, hContextFileSpec, "Paste",  %IDM_PasteFileSpec,  %MF_Enabled
   Menu Add String, hContextFileSpec, "Delete", %IDM_DeleteFileSpec,  %MF_Enabled
   Menu Add String, hContextFileSpec, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContextFileSpec, "Clear File Specs", %IDM_ClearFileSpec,  %MF_Enabled
End Sub

Sub BuildMRU
   If Debug Then Txt.Print FuncName$
   Local lRes As Long
    'always put most recent terms/parent/filespec at top. if exists add search term, if new move to top
   If Len(Trim$(FileSpec)) Then
       ComboBox Find Exact hDlg, %IDC_ComboFileSpec, 1, FileSpec To lRes
       If lRes Then ComboBox Delete hDlg, %IDC_ComboFileSpec, lRes
       ComboBox Insert hDlg, %IDC_ComboFileSpec, 1, FileSpec
       ComboBox Select hDlg, %IDC_ComboFileSpec, 1
   End If
End Sub


Sub BuildAcceleratorTable
   If Debug Then Txt.Print FuncName$
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(6)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1     : ac(c).cmd   = %IDT_Help       : Incr c
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F3     : ac(c).cmd   = %IDT_Search     : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_D      : ac(c).cmd   = %IDM_Debug      : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_F      : ac(c).cmd   = %IDT_Search     : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_G      : ac(c).cmd   = %IDM_GroupIcons : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_P      : ac(c).cmd   = %IDM_CopyPlus   : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_T      : ac(c).cmd   = %IDM_Test       : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Function SetToolTips(cID As Long) As String
   If Debug Then Txt.Print FuncName$
   Select Case cID          'or this:   @P.hdr.idFrom
      Case %IDT_FolderNew  : Function = "Add New Path to List"
      Case %IDT_FolderDel  : Function = "Remove Selected Path From List"
      Case %IDT_Search     : Function = "Search For Files With Matching File Spec (Checked Paths Only)"
      Case %IDT_Dupes      : Function = "Display Duplicate Files from Search Results"
      Case %IDT_Redo       : Function = "Restore Last Search Results"
      Case %IDT_Remove     : Function = "Remove Selected Item From Results List"
      Case %IDT_ViewGroup  : Function = "View Selected Group or Item in External Viewer"
      Case %IDT_Font       : Function = "Select Font for Path and Results Lists"
      Case %IDT_InternalViewer : Function = "Use Internal Viewer to Display Selected Item form Results List"
      Case %IDT_SubFolders : Function = "Include SubFolders In Search"
      Case %IDT_Name       : Function = "Use File Name to Determine Duplicates"
      Case %IDT_Date       : Function = "Use File Date With File Name to Determine Duplicates"
      Case %IDT_Bytes      : Function = "Compare Bytes to Determine Duplicates"
      Case %IDT_Settings   : Function = "Toggle Display of Alternating Line Colors"
      Case %IDT_Help       : Function = "Open Online Help"
      Case Else            : Function = "Unknown"
   End Select
End Function

' -1 if 1st should precede 2nd : +1 if 2nd should precede 2nd
' this routine sorts on the .L (Long) element of the UDT
' Function = IIf(A.L > B.L,-1,+1)        'descending numeric

Function SortByNameDateA(A As DirData, B As DirData) As Long
    Local AName, BName As String
    'by name, then path
    AName = LCase$(PathName$(Namex,A.FileName))
    BName = LCase$(PathName$(Namex,B.FileName))
    Select Case AName
       Case = BName  : Function = IIf(A.LastWriteTime < B.LastWriteTime, -1, +1)
       Case < BName  : Function = +1
       Case > BName  : Function = -1
    End Select
End Function

Function SortByNameA(A As DirData, B As DirData) As Long
    Local AName, BName As String
    'by name, then path
    AName = LCase$(PathName$(Namex,A.FileName))
    BName = LCase$(PathName$(Namex,B.FileName))
    Select Case AName
       Case = BName  : Function = IIf(LCase$(A.FileName) < LCase$(B.FileName), -1, +1)
       Case < BName  : Function = +1
       Case > BName  : Function = -1
    End Select
End Function

Function SortByNameD(A As DirData, B As DirData) As Long
    Local AName, BName As String
    'by name, then path
    AName = LCase$(PathName$(Namex,A.FileName))
    BName = LCase$(PathName$(Namex,B.FileName))
    Select Case AName
       Case = BName  : Function = IIf(LCase$(A.FileName) < LCase$(B.FileName), -1, +1)
       Case < BName  : Function = -1
       Case > BName  : Function = +1
    End Select
End Function

Function SortByPathA(A As DirData, B As DirData) As Long
    Function = IIf(LCase$(A.FileName) > LCase$(B.FileName), -1, +1)
End Function

Function SortByPathD(A As DirData, B As DirData) As Long
    Function = IIf(LCase$(A.FileName) < LCase$(B.FileName), -1, +1)
End Function

Function SortByDateA(A As DirData, B As DirData) As Long
    Function = IIf(A.LastWriteTime < B.LastWriteTime, -1, +1)
End Function

Function SortByDateD(A As DirData, B As DirData) As Long
    Function = IIf(A.LastWriteTime > B.LastWriteTime, -1, +1)
End Function

Function SortBySizeA(A As DirData, B As DirData) As Long
    If Debug Then Txt.Print FuncName$
    Local sA,sB As Long
    sA = A.FileSizeHigh * &H100000000 + A.FileSizeLow
    sB = B.FileSizeHigh * &H100000000 + B.FileSizeLow
    Function = IIf(sA < sB, -1, +1)
End Function

Function SortBySizeD(A As DirData, B As DirData) As Long
    If Debug Then Txt.Print FuncName$
    Local sA,sB As Long
    sA = A.FileSizeHigh * &H100000000 + A.FileSizeLow
    sB = B.FileSizeHigh * &H100000000 + B.FileSizeLow
    Function = IIf(sA > sB, -1, +1)
End Function

Sub SelectAppFont
   If Debug Then Txt.Print FuncName$
   Local Flags As Long, fName$, fSize,fStyle As Long
   Flags = %CF_ScreenFonts Or %CF_ForceFontExist Or %CF_NoSimulations Or %CF_NoScriptSel
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlg, 100,100, FontName, FontSize, FontStyle, Flags To fName$, fSize, fStyle
   If Len(fName$) Then
       FontName = fName$ : FontSize = fSize : FontStyle = fStyle
       Font New FontName, FontSize, FontStyle To hFont
       Control Set Font hDlg, %IDC_LVPaths, hFont
       Control Set Font hDlg, %IDC_LVResults, hFont
   End If
End Sub

Function FontDialogProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
    If nCode = %HCBT_CREATEWND Then
        cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
        cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
        GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
        If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
    End If
End Function

Sub ResizeWindow
   If Debug Then Txt.Print FuncName$
   Local i,iWidth,w,h As Long
   Dialog Get Client hDlg To w,h

   If InternalViewer Then
      Control Set Size hDlg, %IDC_ComboFileSpec, w/2-70, 20
      Control Set Size hDlg, %IDC_LVPaths, w/2-15, 120
      Control Set Size hDlg, %IDC_LVResults, w/2-15, h-235
      Control Set Loc hDlg, %IDC_Viewer, w/2+5,60
      Control Set Size hDlg, %IDC_Viewer, w/2-15,h-85
      LoadSelectedFile(1)
   Else
      Control Set Size hDlg, %IDC_ComboFileSpec, w-75, 20
      Control Set Size hDlg, %IDC_LVPaths, w-20, 120
      Control Set Size hDlg, %IDC_LVResults, w-20, h-235
   End If

   'resize LV columns
   Control Get Client hDlg, %IDC_LVPaths To w,h
   ListView Set Column hDlg, %IDC_LVPaths, 1, w
   Control Get Client hDlg, %IDC_LVResults To w,h
   ListView Fit Header hDlg, %IDC_LVResults, 1
   ListView Fit Header hDlg, %IDC_LVResults, 2
   ListView Fit Header hDlg, %IDC_LVResults, 3
   ListView Get Column hDlg, %IDC_LVResults, 1 To i : iWidth = iWidth + i
   ListView Get Column hDlg, %IDC_LVResults, 2 To i : iWidth = iWidth + i
   ListView Get Column hDlg, %IDC_LVResults, 3 To i : iWidth = iWidth + i
   ListView Set Column hDlg, %IDC_LVResults, 4, Max(0,w-iWidth)

End Sub

Sub RestoreSession
   If Debug Then Txt.Print FuncName$
   Local fName$, temp$
   'read Paths()
   fName$ = "session_paths.dat"
   If IsTrue(IsFile(fName$)) Then
      Open fName$ For Input As #1
      While IsFalse(Eof(1))
         Line Input #1, temp$
         ListView Insert Item hDlg, %IDC_LVPaths, 1, 0, temp$
         Line Input #1, temp$
         ListView_SetCheckState hLVPaths, 0, Val(temp$)
      Wend
      Close #1
   End If

   'read Files()
   fName$ = "session_files.dat"
   If IsTrue(IsFile(fName$)) Then
      ReDim Files(FileCount)
      Open fName$ For Binary As #1
      Get #1,,Files()
      Close #1
   End If

   'read DFiles()
   fName$ = "session_dupes.dat"
   If IsTrue(IsFile(fName$)) Then
      ReDim DFiles(DFileCount)
      Open fName$ For Binary As #1
      Get #1,,DFiles()
      Close #1
   End If

   'read DMatched()
   fName$ = "session_matched.dat"
   If IsTrue(IsFile(fName$)) Then
      ReDim DMatched(DFileCount)
      Open fName$ For Binary As #1
      Get #1,,DMatched()
      Close #1
   End If

   If DisplayMode = %AllFiles Then
      LoadListViewWithAllFiles
   Else
      LoadListViewWithDuplicates
   End If

End Sub

Sub SaveSession
   If Debug Then Txt.Print FuncName$
   Local i,iCount,iResult As Long, temp$, fName$
   'PUT PATHS
   ListView Get Count hDlg, %IDC_LVPaths To iCount
   fName$ = "session_paths.dat"
   Open fName$ For Output As #1
   If iCount Then
      For i = iCount To 1 Step -1
         ListView Get Text hDlg, %IDC_LVPaths, i,1 To temp$
         Print #1, temp$
         iResult = ListView_GetCheckState(hLVPaths,i-1)
         Print #1, Str$(iResult)
      Next i
   End If
   Close #1

   'PUT Files()
   fName$ = "session_files.dat"
   If IsTrue(IsFile(fName$)) Then Kill fName$
   Open fName$ For Binary As #1
   Put #1,, Files()
   Close #1

   'PUT DFiles()
   fName$ = "session_dupes.dat"
   If IsTrue(IsFile(fName$)) Then Kill fName$
   Open fName$ For Binary As #1
   Put #1,, DFiles()
   Close #1

   'PUT FileMatched()
   fName$ = "session_matched.dat"
   If IsTrue(IsFile(fName$)) Then Kill fName$
   Open fName$ For Binary As #1
   Put #1,, DMatched()
   Close #1

End Sub

Sub CheckAllPaths(Flag As Long)  '1 = checked  0 = unchecked
   If Debug Then Txt.Print FuncName$
   Local i, iCount As Long
   ListView Get Count hDlg, %IDC_LVPaths To iCount
   For i = 1 To iCount
      ListView_SetCheckState hLVPaths, i-1, Flag
   Next i
End Sub

Sub CheckAllResults(Flag As Long)  '1 = checked  0 = unchecked
   If Debug Then Txt.Print FuncName$
   Local i, iCount As Long
   ListView Get Count hDlg, %IDC_LVResults To iCount
   For i = 1 To iCount
      ListView_SetCheckState hLVResults, i-1, Flag
   Next i
End Sub

Sub MoveCheckedPathsToTop
   If Debug Then Txt.Print FuncName$
   Local i, iCount As Long, temp$
   ListView Get Count hDlg, %IDC_LVPaths To iCount
   For i = iCount To 1 Step -1
      If ListView_GetCheckState(hLVPaths, i-1) Then
         ListView Get Text hDlg, %IDC_LVPaths, i,1 To temp$
         ListView Delete Item hDlg, %IDC_LVPaths, i
         ListView Insert Item hDlg, %IDC_LVPaths, 1, 0, temp$
         ListVIew_SetCheckState hLVPaths, 1, %True
      End If
   Next i
End Sub

Function MsgProc(ByVal lMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long    'MsgBox is approximately 200x200
   CenterOverDialog 200,200,x,y
   If lMsg = %HCBT_ACTIVATE Then
      SetWindowPos wParam, 0, x,y, 0, 0, %SWP_NOSIZE Or %SWP_NOACTIVATE Or %SWP_NOZORDER
      UnhookWindowsHookEx ghHook
   End If
End Function

Sub CenterOverDialog(BoxX As Long, BoxY As Long, CenterX As Long, CenterY As Long)
   If Debug Then Txt.Print FuncName$
   'gets top/left position to center Box over Dialog
   'you need to know, or at least estimate, the Box size
   Local x As Long, y As Long, w As Long, h As Long
   Dialog Get Loc hDlg To x,y
   Dialog Get Size hDlg To w,h
   CenterX = x + (w-BoxX)/2
   CenterY = y + (h-BoxY)/2
End Sub

Sub Search
    If Debug Then Txt.Print FuncName$
    Local text$,ParentFolder$, i,iCount As Long
    MousePtr 11

    Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Starting search for matching files ..."
    QueryPerformanceCounter qStart
    SendMessage GetDlgItem(hDlg,%IDC_LVResults), %WM_SetRedraw, %False, 0

    'get textbox content
    Control Get Text hDlg, %IDC_ComboFileSpec To FileSpec
    If ImpliedSearch Then FileSpec = "*" + Trim$(FileSpec,"*") + "*"
    BuildMRU

    'put matching file names in array Files()
    ListView Get Count hDlg, %IDC_LVPaths To iCount
    If iCount = 0 Then
       Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Search cancelled!"
       ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(MsgProc), GetModuleHandle(""), GetCurrentThreadId)
       MessageBox(0, "No search paths found!", "Search", %MB_Ok + %MB_IconExclamation)
       Exit Sub
    End If

    ListView Reset hDlg, %IDC_LVResults
    ReDim Files(5000) : FileCount = 0
    For i = 1 To iCount
       If ListView_GetCheckState(hLVPaths,i-1) Then
          ListView Get Text hDlg, %IDC_LVPaths, i,1 To ParentFolder$
          ReDim Folders(500) : FolderCount = 0
          GetFileList ParentFolder$, FileSpec
       End If
    Next i
    ReDim Preserve Files(FileCount)
    ReDim DMatched(FileCount)  '<------------- remove any previous content

    'put filelist into LVrResult
    LoadListViewWithAllFiles
    If DisplayMode = %DupeFiles Then DisplayGroupIcons

    SendMessage GetDlgItem(hDlg,%IDC_LVResults), %WM_SetRedraw, %True, 0
    QueryPerformanceCounter qStop
    MousePtr 1

    ResizeWindow
    Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Matching Files Found: " + Str$(UBound(Files)) + "     Elapsed Time: " + Format$((qStop-qStart)/qFreq,"0.###") & " seconds"
    Sleep 1000
End Sub

Sub GetFileList_old (ParentFolder$, FileSpec$)
   If Debug Then Txt.Print FuncName$
   Local iPos As Long, tempDIR As DirData, temp$, FileAttributes As Long, AllFileCount As Long
   FileAttributes = %Normal + SubFolders * %SubDir + IncludeHidden * (%Hidden + %System)
   Folders(iPos).FileName = ParentFolder$     'no ending \
   Do While Len(Folders(iPos).FileName)
       temp$ = Dir$(Folders(iPos).FileName + "\*.*", FileAttributes, To tempDir)
       Do While Len(temp$)
           tempDir.FileName = Folders(iPos).FileName + "\" + tempDir.FileName
           If (tempDir.FileAttributes And %File_Attribute_Directory) = 0 Then  'files
               If PathMatchSpec((PathName$(Namex,tempDir.Filename)), (FileSpec$)) Then
                   Incr FileCount  :  Files(FileCount) = tempDir
                   If FileCount >= UBound(Files) Then ReDim Preserve Files(UBound(Files)+500)
               End If
               Incr AllFileCount
           Else                                                                'folder
               Incr FolderCount    :  Folders(FolderCount) = tempDir
               If FolderCount >= UBound(Folders) Then ReDim Preserve Folders(UBound(Folders)+5000)
           End If
           temp$ = Dir$(Next, To tempDir)
           Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Folders Searched: " + Str$(FolderCount) + "        Files Searched: " + Str$(AllFileCount)  + "        Matching Files: " + Str$(FileCount)
           If AllFileCount Mod 10 = 0 Then Sleep 0
       Loop
       Incr iPos
   Loop
End Sub

Sub GetFileList (ParentFolder$, FileSpec$)
   If Debug Then Txt.Print FuncName$
   Local iPos As Long, tempDIR As DirData, temp$, FileAttributes As Long, AllFileCount As Long, FileSize As Quad
   FileAttributes = %Normal + SubFolders * %SubDir + IncludeHidden * (%Hidden + %System)
   Folders(iPos).FileName = ParentFolder$     'no ending \
   Do While Len(Folders(iPos).FileName)
       temp$ = Dir$(Folders(iPos).FileName + "\*.*", FileAttributes, To tempDir)
       Do While Len(temp$)
           tempDir.FileName = Folders(iPos).FileName + "\" + tempDir.FileName
           If (tempDir.FileAttributes And %File_Attribute_Directory) = 0 Then  'files
               If PathMatchSpec((PathName$(Namex,tempDir.Filename)), (FileSpec$)) Then
                  If SkipZero Then
                     If tempDir.FileSizeHigh * &H100000000 + tempDir.FileSizeLow Then
                        Incr FileCount  :  Files(FileCount) = tempDir
                     End If
                  Else
                     Incr FileCount  :  Files(FileCount) = tempDir
                  End If
                  If FileCount >= UBound(Files) Then ReDim Preserve Files(UBound(Files)+500)
               End If
               Incr AllFileCount
           Else                                                                'folder
               Incr FolderCount    :  Folders(FolderCount) = tempDir
               If FolderCount >= UBound(Folders) Then ReDim Preserve Folders(UBound(Folders)+5000)
           End If
           temp$ = Dir$(Next, To tempDir)
           If AllFileCount Mod 100 = 0 Then Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Folders Searched: " + Str$(FolderCount) + "        Files Searched: " + Str$(AllFileCount)  + "        Matching Files: " + Str$(FileCount)
'           If AllFileCount Mod 100 = 0 Then Sleep 0
       Loop
       Incr iPos
   Loop
End Sub

Sub DeleteSelected
   If Debug Then Txt.Print FuncName$
   Local iResult,iCount As Long, temp$
   ListView Get Count hdlg, %IDC_LVResults To iCount
   ListView Get Select hDlg, %IDC_LVResults To iResult
   If iResult = 0 Then Exit Sub
   ListView Get Text hDlg, %IDC_LVResults, iResult,4 To temp$
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(MsgProc), GetModuleHandle(""), GetCurrentThreadId)
   Select Case MessageBox(0, "Send file to Recycle Bin? " + $CrLf + $CrLf + temp$, "Delete Selection", %MB_OkCancel + %MB_IconQuestion)
      Case %IdOk
         ListView Delete Item hDlg, %IDC_LVResults, iResult
         ? Str$(RecycleBin(temp$))
'         Kill temp$
         If DisplayMode = %AllFiles Then
            Array Delete Files(iResult)
         Else
            Array Delete DFiles(iResult)
            Array Delete DMatched(iResult)
         End If

         ListView Get Count hDlg, %IDC_LVResults To iCount
         If iResult > iCount Then iResult = iCount
'         ListView Select hDlg, %IDC_LVResults, iResult
         ListView_SetItemState hLVResults, iResult-1, %LVIS_Focused Or %LVIS_Selected, %LVIS_Focused Or %LVIS_Selected  '<--- synchronizing code
         Control Set Focus hDlg, %IDC_LVResults
      Case %IdCancel
         'no action
   End Select
End Sub

Sub RemoveSelected
   If Debug Then Txt.Print FuncName$
   Local iResult,iCount As Long, temp$
   ListView Get Count hDlg, %IDC_LVResults To iCount
   ListView Get Select hDlg, %IDC_LVResults To iResult
   If iResult = 0 Then Exit Sub
   ListView Get Text hDlg, %IDC_LVResults, iResult,1 To temp$
   ListView Delete Item hDlg, %IDC_LVResults, iResult
   If DisplayMode = %AllFiles Then
      Array Delete Files(iResult)
      ReDim Preserve Files(UBound(Files)-1)
   Else
      Array Delete DFiles(iResult)
      Array Delete DMatched(iResult)
      ReDim Preserve DFiles(UBound(DFiles)-1)
      ReDim Preserve DMatched(UBound(DMatched)-1)
   End If

   ListView Get Count hDlg, %IDC_LVResults To iCount
   If iResult > iCount Then iResult = iCount
'   ListView Select hDlg, %IDC_LVResults, iResult
   ListView_SetItemState hLVResults, iResult-1, %LVIS_Focused Or %LVIS_Selected, %LVIS_Focused Or %LVIS_Selected  '<--- synchronizing code
   Control Set Focus hDlg, %IDC_LVResults

End Sub

Sub RemoveChecked
   If Debug Then Txt.Print FuncName$
   Local i,iCount,iResult,iDeleted As Long
   ListView Get Count hDlg, %IDC_LVResults To iCount
   ListView Get Select hDlg, %IDC_LVResults To iResult
   If iCount = 0 Then Exit Sub
   For i = iCount To 1 Step -1
      If ListView_GetCheckState(hLVResults,i-1) Then
         Incr iDeleted
         ListView Delete Item hDlg, %IDC_LVResults, i
         If DisplayMode = %AllFiles Then
            Array Delete Files(i)
         Else
            Array Delete DFiles(i)
            Array Delete DMatched(i)
         End If
      End If
   Next i

   If DisplayMode = %AllFiles Then
      ReDim Preserve Files(UBound(Files)-iDeleted)
   Else
      ReDim Preserve DFiles(UBound(DFiles)-iDeleted)
      ReDim Preserve DMatched(UBound(DMatched)-iDeleted)
   End If

   ListView Get Count hDlg, %IDC_LVResults To iCount
   If iResult > iCount Then iResult = iCount
'   ListView Select hDlg, %IDC_LVResults, iResult
   ListView_SetItemState hLVResults, iResult-1, %LVIS_Focused Or %LVIS_Selected, %LVIS_Focused Or %LVIS_Selected  '<--- synchronizing code
   Control Set Focus hDlg, %IDC_LVResults

End Sub

Sub ManageDebug
   If Debug Then Txt.Print FuncName$
   If Debug Then
      Txt.Window "Debug", 300,300,40,40 To hDebug
      Txt.Print "TXT Window Opened"
   Else
      Txt.End
   End If
End Sub

Sub SortPaths
   If Debug Then Txt.Print FuncName$
   Local i,iCount As Long, temp$
   'put paths in array
   ListView Get Count hDlg, %IDC_LVPaths To iCount
   Dim Paths(1 To iCount) As String, Checked(1 To iCount) As Long
   For i = 1 To iCount
      ListView Get Text hDlg, %IDC_LVPaths, i,1 To temp$
      Checked(i) = ListView_GetCheckState(hLVPaths,i-1)
      Paths(i) = temp$
   Next i
   'sort Paths()
   If SortDirectionPaths Then
      Array Sort Paths(), Collate UCase, TagArray Checked(), Ascend
   Else
      Array Sort Paths(), Collate UCase, TagArray Checked(), Descend
   End If
   'return array
   ListView Reset hDlg, %IDC_LVPaths
   For i = 1 To iCount
      ListView Insert Item hDlg, %IDC_LVPaths, 1,0, Paths(i)
      ListView_SetCheckState hLVPaths, 0,Checked(i)
   Next i
'   ListView Select hdlg, %IDC_LVPaths, 1
   ListView_SetItemState hLVResults, 0, %LVIS_Focused Or %LVIS_Selected, %LVIS_Focused Or %LVIS_Selected  '<--- synchronizing code
End Sub

Sub DisplayFileProperties
   Local i,iResult,w,h As Long, F As DirData, UST,LST As SystemTime, temp$, Msg$, fName$, Extn$
   ListView Get Select hDlg, %IDC_LVResults To iResult
   If iResult = 0 Then Exit Sub
   ListView Get Text hDlg, %IDC_LVResults, iResult, 4 To fName$
   Msg$ = Msg$ + $CrLf + PathName$(Namex,fName$)
   Msg$ = Msg$ + $CrLf + fName$
   temp$ = Dir$(fName$, 0, To F)
   FileTimeToSystemTime(ByVal VarPtr(F.LastWriteTime),UST)  'UTC
   SystemTimeToTzSpecificLocalTime(ByVal %Null, UST,LST)    'Local
   Msg$ = Msg$ + $CrLf + Format$(LST.wYear,"00") + "-" + Format$(LST.wMonth,"00") + "-" + Format$(LST.wDay,"00") + "  " _
        + Format$(LST.wHour,"00") + ":" + Format$(LST.wMinute,"00")
   Msg$ = Msg$ + $CrLf + Format$(F.FileSizeHigh * &H100000000 + F.FileSizeLow, "###,###,###,##0")

   Extn$ = LCase$(PathName$(Extn,fName$))
   If InStr(ValidTextExt,Extn$ ) Then
         temp$ = GetFileText(fName$)
         Msg$ = Msg$ + $CrLf + $CrLf + "Text File" + $CrLf + "Lines: " + Str$(ParseCount(temp$,$CrLf))
   ElseIf Extn$ = ".bmp" Then
         GetBMPSize fName$, w,h
         Msg$ = Msg$ + $CrLf + $CrLf + "Image File" + $CrLf + "Size: " + Str$(w) + " x" + Str$(h)
   ElseIf Extn$ = ".ico" Then
         GetIconSize fName$, w,h
         Msg$ = Msg$ + $CrLf + $CrLf + "Image File" + $CrLf + "Size: " + Str$(w) + " x" + Str$(h)
   ElseIf InStr(ValidImageExt, Extn$) Then
         GetImageSize fName$, w,h
         Msg$ = Msg$ + $CrLf + $CrLf + "Image File" + $CrLf + "Size: " + Str$(w) + " x" + Str$(h)
   End If
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(MsgProc), GetModuleHandle(""), GetCurrentThreadId)
   MessageBox(0, (Msg$), "File Properties", %MB_Ok + %MB_IconInformation)
End Sub

Sub DisplaySummary
   If Debug Then Txt.Print FuncName$
   Local iCount,i As Long, temp$
   Local ExtTxt,ExtBas,ExtInc,ExtBmp,ExtJpg,ExtGIf,ExtIco,ExtExe,ExtDLL,ExtOth As Long

   ListView Get Count hDlg, %IDC_LVResults To iCount
   UpdateStatusBar

   For i = 1 To iCount
       ListView Get Text hDlg, %IDC_LVResults, i, 1  To temp$
       If temp$ = "<no duplicates>" Then Iterate For
       temp$ = LCase$(Right$(temp$,4))
       If InStr(temp$, ".txt") Then
          Incr ExtTxt
       ElseIf InStr(temp$, ".bas") Then
          Incr ExtBas
       ElseIf InStr(temp$, ".inc") Then
          Incr ExtInc
       ElseIf InStr(temp$, ".bmp") Then
          Incr ExtBmp
       ElseIf InStr(temp$, ".jpg") Then
          Incr ExtJpg
       ElseIf InStr(temp$, ".gif") Then
          Incr ExtGif
       ElseIf InStr(temp$, ".ico") Then
          Incr ExtIco
       ElseIf InStr(temp$, ".exe") Then
          Incr ExtExe
       ElseIf InStr(temp$, ".dll") Then
          Incr ExtDll
       Else
          Incr ExtOth
       End If
   Next i
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(MsgProc), GetModuleHandle(""), GetCurrentThreadId)
   MessageBox(0, _
        "Extension Count:" + $CrLf + _
        "txt" + $Tab + Format$(ExtTxt,"##,###") + $CrLf + _
        "bas" + $Tab + Format$(ExtBas,"##,###") + $CrLf + _
        "inc" + $Tab + Format$(ExtInc,"##,###") + $CrLf + _
        "bmp" + $Tab + Format$(ExtBmp,"##,###") + $CrLf + _
        "jpg" + $Tab + Format$(ExtJpg,"##,###") + $CrLf + _
        "gif" + $Tab + Format$(ExtGif,"##,###") + $CrLf + _
        "ico" + $Tab + Format$(ExtIco,"##,###") + $CrLf + _
        "exe" + $Tab + Format$(ExtExe,"##,###") + $CrLf + _
        "dll" + $Tab + Format$(ExtDll,"##,###") + $CrLf + _
        "oth" + $Tab + Format$(ExtOth,"##,###") + $CrLf + _
        "Total"  + $Tab + Format$(iCount,"##,###") + $CrLf + $CrLf + _
        "Left:"  + $Tab + CompareLeft + $CrLf + _
        "Right:" + $Tab + CompareRight + $CrLf + _
        "App:"   + $Tab + CompareApp + $CrLf + $CrLf + _
        "Display:" + $Tab + IIf$(DisplayMode=%AllFiles,"All Files","Duplicates Only"), _
        "Summary", %MB_Ok + %MB_IconInformation)
   UpdateStatusBar
End Sub

Sub UpdateStatusBar
   Local iCount As Long, temp$
   ListView Get Count hDlg, %IDC_LVResults To iCount
   ListView Get Text hDlg, %IDC_LVResults, 1, 1  To temp$
   Select Case iCount
      Case 1
         If temp$ = "<no files>" Or temp$ = "<no duplicates>" Then
            Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Files Found:  0"
         End If
      Case Else  '0 or >1
         Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "File Count: " + Str$(iCount)
   End Select
End Sub

Function GetFileText(fName As String) As String
   On Error GoTo GetFileError
   If Debug Then Txt.Print FuncName$
   Local temp$
   If IsFalse(IsFile(fName)) Then Exit Function
   Open fName For Binary As #1
   Get$ #1, Lof(1), temp$
   Close #1
   Function = temp$
   Exit Function
GetFileError:
ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(MsgProc), GetModuleHandle(""), GetCurrentThreadId)
MessageBox(0, "Error: " + Str$(Err) + $CrLf + fName , "Get File Text", %MB_Ok + %MB_IconExclamation)
End Function

Sub LoadListViewWithAllFiles()
   If Debug Then Txt.Print FuncName$
   Local i As Long
   DisplayMode = %AllFiles
   ListView Reset hDlg, %IDC_LVResults
   For i = 1 To UBound(Files)
      AddFileNameToListView_AllFiles i,i
   Next i
End Sub

Sub LoadListViewWithDuplicates()
   If Debug Then Txt.Print FuncName$
   Local i As Long
   DisplayMode = %DupeFiles
   ListView Reset hDlg, %IDC_LVResults
   For i = 1 To UBound(DFiles)
      AddFileNameToListView_DupeFiles i,i
   Next i
End Sub

Sub AddFileNameToListView_AllFiles(iRow As Long, iPos As Long)
'   If Debug Then Txt.Print FuncName$
    Local UST,LST As SystemTime, temp$
    temp$ = Files(iPos).Filename
    ListView Insert Item hDlg, %IDC_LVResults, iRow, 0, PathName$(Namex,temp$)
    ListView Set Text    hDlg, %IDC_LVResults, iRow, 4, Files(iPos).FileName

    FileTimeToSystemTime(ByVal VarPtr(Files(iPos).LastWriteTime),UST)  'UTC
    SystemTimeToTzSpecificLocalTime(ByVal %Null, UST,LST)              'Local
    ListView Set Text hDlg, %IDC_LVResults, iRow,3, _
        Format$(LST.wYear,"00") + "-" + Format$(LST.wMonth,"00") + "-" + Format$(LST.wDay,"00") + "  " _
        + Format$(LST.wHour,"00") + ":" + Format$(LST.wMinute,"00") '+ ":" + Format$(LST.wSecond,"00")

    temp$ = Str$(Files(iPos).FileSizeHigh * &H100000000 + Files(iPos).FileSizeLow)
    If UseKB And (Val(temp$) < 1024) Then
       ListView Set Text hDlg, %IDC_LVResults, iRow,2, "< 1"
    Else
       ListView Set Text hDlg, %IDC_LVResults, iRow,2, Format$(Val(temp$)/IIf(UseKB,1024,1),"#,###,###") ' + "    "
    End If
End Sub

Sub SelectCompareApp
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    title$ = ""    'caption title. if "", then "Open" is displayed
    filter$ = Chr$("Applications",0,"*.exe",0)
    startfolder$ = (CompareApp)     'initial folder to be displayed
    startfile$ = (CompareApp)       'name to be used as initial selection
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then CompareApp = filevar$
End Sub

Sub AddFileNameToListView_DupeFiles(iRow As Long, iPos As Long)
'   If Debug Then Txt.Print FuncName$
    Local UST,LST As SystemTime, temp$
    temp$ = DFiles(iPos).Filename
    ListView Insert Item hDlg, %IDC_LVResults, iRow, 0, PathName$(Namex,temp$)
    ListView Set Text    hDlg, %IDC_LVResults, iRow, 4, DFiles(iPos).FileName

    FileTimeToSystemTime(ByVal VarPtr(DFiles(iPos).LastWriteTime),UST)  'UTC
    SystemTimeToTzSpecificLocalTime(ByVal %Null, UST,LST)              'Local
    ListView Set Text hDlg, %IDC_LVResults, iRow,3, _
        Format$(LST.wYear,"00") + "-" + Format$(LST.wMonth,"00") + "-" + Format$(LST.wDay,"00") + "  " _
        + Format$(LST.wHour,"00") + ":" + Format$(LST.wMinute,"00") '+ ":" + Format$(LST.wSecond,"00")

    temp$ = Str$(DFiles(iPos).FileSizeHigh * &H100000000 + DFiles(iPos).FileSizeLow)
    If UseKB And (Val(temp$) < 1024) Then
       ListView Set Text hDlg, %IDC_LVResults, iRow,2, "< 1"
    Else
       ListView Set Text hDlg, %IDC_LVResults, iRow,2, Format$(Val(temp$)/IIf(UseKB,1024,1),"#,###,###") ' + "    "
    End If
End Sub

Sub FindDuplicatesNames
   If Debug Then Txt.Print FuncName$
   Local i,iPos,NewColor As Long, temp$

   'Exit if no files available
   ListView Get Text hDlg, %IDC_LVResults, 1, 1  To temp$
   If temp$ = "<no files>" Or temp$ = "<no duplicates>" Then
      Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Duplicates Found:  0"
      Exit Sub
   End If

   'ReDim arrays
   QueryPerformanceCounter qStart
   MousePtr 11
   Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Starting search for duplicate files ..."
   If UseDate Then
      Array Sort Files(1) For UBound(Files), Call SortByNameDateA()
   Else
      Array Sort Files(1) For UBound(Files), Call SortByNameA()
   End If
   ReDim DFiles(UBound(Files)), DMatched(UBound(Files))

   'compare each element to all other elements, put matches into listbox
   For i = 1 To UBound(Files)-1
      Sleep 0
      Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Comparison Status ... %" +  Format$(100*i/(UBound(Files)-1),"##0")
      Select Case LCase$(PathName$(Namex,Files(i).filename))
         Case LCase$(PathName$(Namex,Files(i-1).filename))
            'part of previous group
            If UseDate And Files(i).lastwritetime <> Files(i-1).lastwritetime Then Exit Select
            Incr iPos
            DFiles(iPos) = Files(i)
            DMatched(iPos) = NewColor
         Case LCase$(PathName$(Namex,Files(i+1).filename))
            'start of new group
            If UseDate And Files(i).lastwritetime <> Files(i+1).lastwritetime Then Exit Select
            Incr iPos
            DFiles(iPos) = Files(i)
            NewColor = NewColor Xor 1
            DMatched(iPos) = NewColor
         Case Else
            'not a duplicate file
      End Select
   Next i

   'check last item
   If LCase$(PathName$(Namex,Files(i).filename)) = LCase$(PathName$(Namex,Files(i-1).filename)) Then
      'part of previous group
      If UseDate And Files(i).lastwritetime <> Files(i-1).lastwritetime Then Exit If
      Incr iPos
      DFiles(iPos) = Files(i)
      DMatched(iPos) = NewColor
   End If


   ReDim Preserve DFiles(iPos), DMatched(iPos)
   LoadListViewWithDuplicates
   CheckAllResults(1)
   QueryPerformanceCounter qStop
   MousePtr 1
   Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Duplicates Found: " + Str$(UBound(DFiles)) + "     Elapsed Time: " + Format$((qStop-qStart)/qFreq,"0.###") & " seconds"
   Sleep 1000
End Sub

Function SelectColor(startcolor&) As Long    'works on pControl
   If Debug Then Txt.Print FuncName$
   Local ColorResult&
   Display Color hDlg, 200, 200, startcolor&, CustomColorList ,0 To ColorResult&
   If ColorResult& = -1 Then Function = startcolor& Else Function = ColorResult&
End Function

Sub GetGroupBoundary(iPos As Long, FirstItem As Long, LastItem As Long)
   Local i As Long
   'go backwards to get position of group
   FirstItem = iPos
   For i = iPos-1 To 1 Step -1
      If DMatched(i) = DMatched(iPos) Then FirstItem = i Else Exit For
   Next i
   'go backwards to get position of group
   LastItem = iPos
   For i = iPos+1 To UBound(DMatched)
      If DMatched(i) = DMatched(iPos) Then LastItem = i Else Exit For
   Next i
End Sub

Sub BuildLastSearch
   Local i As Long
   ReDim LastSearch(UBound(Files))
   For i = 1 To UBound(Files)
      LastSearch(i) = Files(i)
   Next i
End Sub

Sub RestoreLastSearch
   Local i As Long
   If UBound(LastSearch) = -1 Then
      'no search this session
       ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(MsgProc), GetModuleHandle(""), GetCurrentThreadId)
       MessageBox(0, "No search performed in this session!", "Restore Last Search", %MB_Ok + %MB_IconExclamation)
   Else
      ReDim Files(UBound(LastSearch))
      ReDim DMatched(UBound(LastSearch))
      For i = 1 To UBound(LastSearch)
         Files(i) = LastSearch(i)
      Next i
   End If
End Sub

Sub ShowGroup
   Local FileList,FileName As String, i,iCount,iResult,GroupStart,GroupEnd As Long

   ListView Get Select hDlg, %IDC_LVResults To iResult
   If iResult = 0 Then Exit Sub
   GetGroupBoundary(iResult,GroupStart,GroupEnd)  'x=start y='end

   'create file list
   ListView Get Count hDlg, %IDC_LVResults To iCount
   For i = GroupStart To GroupEnd
      ListView Get Text hDlg, %IDC_LVResults, i, 4 To FileName
      FileList = FileName + ";" + FileList
   Next i
   FileList = Trim$(FileList,";")

   'open the viewer
   gViewer "gbMultiViewer", _     'title to use in dialog
           hDlg, _            'parent handle
           FileList, _        'file list, semicolon separated
           "logo", _          'resource icon for gbMultiViewer dialog
           "unsupported", _   'resource icon for unsupported file types
           100, _             'x position relative to parent upper-left
           100, _             'y position relative to parent upper-left
           400, _             'viewer width
           400, _             'viewer height
           3, _               'columns
           3, _               'rows
           5000, _            'control ID starting value
           %White, _          'background color
           0, _               'display mode  0-upperleft 1-center/resized(stretched)
           1, _               'show names    0-no 1-yes
           1, _               'show borders  0-no 1-yes
           0, _               'show paths in filename 0-no 1-yes
           0, _               'transparent image background
           1, _               'calculate row/column values for best fit
           0, _               'automatically refreshes dislayed files
           60, _              'refresh period (seconds)
           1                  'use INI file  0-no 1-yes
End Sub

Sub DisplayGroupIcons
   Local i,iCount As Long
   If DIsplayMode = %AllFiles Then Exit Sub
   ListView Get Count hDlg, %IDC_LVResults To iCount
   If GroupIcons Then
      'use icons
      ListView Set ImageList hDlg, %IDC_LVResults, hImageListGroup, %lvsil_small
      ListView Set Image hDlg, %IDC_LVResults, 1, 1 'top
      ListView Set Image hDlg, %IDC_LVResults, iCount, 3  'bottom
      For i = 2 To iCount-1
         If DMatched(i) = DMatched(i-1) Then
            ListView Set Image hDlg, %IDC_LVResults, i, 2  'mid
         Else
            ListView Set Image hDlg, %IDC_LVResults, i-1, 3 'bottom
            ListView Set Image hDlg, %IDC_LVResults, i, 1 'top
         End If
      Next i
   Else
      'not use icons
      ListView Set ImageList hDlg, %IDC_LVResults, hImageListEmpty, %lvsil_small
   End If
   Control ReDraw hDlg, %IDC_LVResults
End Sub

Sub FindDuplicatesBinary_new
   If Debug Then Txt.Print FuncName$
   Local i,j,iPos,NewFlag,NewColor As Long, r,s As Quad, temp$
   Dim FileMatched() As Long

   'Exit if no files available
   ListView Get Text hDlg, %IDC_LVResults, 1, 1  To temp$
   If temp$ = "<no files>" Or temp$ = "<no duplicates>" Then
      Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Duplicates Found:  0"
      Exit Sub
   End If

   'sort
   Array Sort Files(1) For UBound(Files), Call SortBySizeD()

   'not all text files are read. when read, put in Global array so can have more memory
   QueryPerformanceCounter qStart
   MousePtr 11
   Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Starting search for duplicate files ..."
   ReDim FileStrings(UBound(Files)), DFiles(UBound(Files)), FileMatched(UBound(Files)), DMatched(UBound(Files))
'   For i = 1 To UBound(Files) : FileStrings(i) = GetFileText((Files(i).FileName)) : Next i

   'compare each element to all other elements, put matches into listbox
   For i = 1 To UBound(Files) - 1
      Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Comparison Status ... %" +  Format$(100*i/(UBound(Files)-1),"##0")
      Sleep 0
      NewFlag = 1
      If FileMatched(i) Then Iterate For
      r = Files(i).FileSizeHigh * &H100000000 + Files(i).FileSizeLow
      For j = i+1 To UBound(Files)
         s = Files(j).FileSizeHigh * &H100000000 + Files(j).FileSizeLow
         If s < r Then Exit For
         If r = s Then
            If Len(FileStrings(i)) = 0 Then FileStrings(i) = GetFileText((Files(i).FileName))
            If Len(FileStrings(j)) = 0 Then FileStrings(j) = GetFileText((Files(j).FileName))
            If FileStrings(i) = FileStrings(j) Then
               If NewFlag Then
                  Incr iPos : DFiles(iPos) = Files(i) : NewFlag = 0
                  NewColor = NewColor Xor 1 : DMatched(iPos) = NewColor
               End If
               FileMatched(j) = 1
               Incr iPos : DFiles(iPos) = Files(j) : DMatched(iPos) = NewColor
            End If
         End If
      Next j
   Next i

   ReDim Preserve DFiles(iPos), DMatched(iPos)
   LoadListViewWithDuplicates
   CheckAllResults(1)
   QueryPerformanceCounter qStop
   MousePtr 1
   Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Duplicates Found: " + Str$(UBound(DFiles)) + "     Elapsed Time: " + Format$((qStop-qStart)/qFreq,"0.###") & " seconds"
   Sleep 1000
End Sub

Sub WastedSpace
   Local i,iCount As Long,iSize As Quad, temp$
   ListView Get Count hDlg, %IDC_LVResults To iCount
   For i = 2 To iCount
      If DMatched(i-1) = DMatched(i) Then
         ListView Get Text hDlg, %IDC_LVResults, i, 2 To temp$
         iSize = iSize + Val(temp$)
      End If
   Next i
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(MsgProc), GetModuleHandle(""), GetCurrentThreadId)
   If UseKB Then
      temp$ = Format$(iSize/1024,"###,###,###,###.0") + " KB"
   Else
      temp$ = Format$(iSize,"###,###,###,###") + " bytes"
   End If
   MessageBox(0, "Potential space savings by eliminating duplicate:" + $CrLf + $CrLf + temp$, "Wasted Space", %MB_Ok + %MB_IconInformation)
End Sub

Sub LoadSelectedFile (FromResizeWindow As Long)
   Local iResult,Style As Long, fName$, fExt$, StatusBarData$, fText$
   Local wCont,hCont,wNew,hNew,x,y,w,h,wImg,hImg As Long, hBMP,hDC As Dword
   Style = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll Or %ES_AutoHScroll _
            Or %WS_HScroll Or %ES_AutoVScroll Or %ES_WantReturn Or %WS_TabStop

   'determine file type of selected item
   ListView Get Select hDlg, %IDC_LVResults To iResult
   If iResult = 0 Then Exit Sub
   ListView Get Text hDlg, %IDC_LVResults, iResult, 4 To fName$
   If Len(fName$) = 0 Then Exit Sub
   fExt$ = PathName$(Extn, fName$)

   Select Case LCase$(fExt$)
      Case ".bas", ".inc", ".bas", ".txt"
         SelectedFileType = %TextFile
      Case ".ico", ".bmp", ".jpg", ".gif", ".png"
         SelectedFileType = %ImageFile
      Case Else
         SelectedFileType = %OtherFile
   End Select

   'create viewer control, but only if is wrong control type
   If ViewerControlType <> SelectedFileType Then
      'must kill current IDC_Viewer and make a new one of the correct type (TextBox or Graphic Control)
      Control Get Size hDlg, %IDC_Viewer To w,h
      Control Get Loc hDlg, %IDC_Viewer To x,y
      Control Kill hDlg, %IDC_Viewer
      Select Case SelectedFileType
         Case %TextFile
            'create textbox
            Control Add TextBox, hDlg, %IDC_Viewer,"",1,1,10,10,Style, %WS_Ex_ClientEdge
            ViewerControlType = %TextFile
         Case %ImageFile
            'create graphic control
            Control Add Graphic, hDlg, %IDC_Viewer,"",1,1,10,10, %WS_Border
            ViewerControlType = %ImageFile
         Case %OtherFile
            'create textbox
            Control Add TextBox, hDlg, %IDC_Viewer,"<unsupported file type>",1,1,10,10, Style, %WS_Ex_ClientEdge
            ViewerControlType = %OtherFile
      End Select
      If FromResizeWindow = 0 Then ResizeWindow
   End If

   'display the file
   StatusBarData$ = PathName$(Namex,fName$)
   Select Case SelectedFileType
      Case %TextFile
         fText$ = GetFileText(fName$)
         Control Set Text hDlg, %IDC_Viewer, fText$
         If Len(fText$) Then
            StatusBarData$ = StatusBarData$ + "   Line Count: " + Str$(ParseCount(fText$,$CrLf))
         Else
            StatusBarData$ = StatusBarData$ + "   Line Count:  0"
         End If
      Case %ImageFile
            'for images only
            Graphic Attach hDlg, %IDC_Viewer
            Graphic Color %Black, IIf(Transparent, -1, BGColor)
            Graphic Clear
            'redraw image
            If Stretched Then            'stretch image to fit control
               Graphic Set StretchMode %HalfTone
               Graphic Get Client To wCont,hCont     'wCont,hCont = container size : hImg,wImg = original image size
               Select Case fExt$
                  Case ".ico"
                     GetIconSize fName$,wImg,hImg
                     StatusBarData$ = StatusBarData$ + "   Size: " + Str$(wImg) + " x" + Str$(hImg)
                     wNew = wImg / Max(wImg / wCont, hImg / hCont)  'wNew,hNew = image size to fit in container
                     hNew = hImg / Max(wImg / wCont, hImg / hCont)  'wNew,hNew = image size to fit in container
                     If Centered Then
                        x = (wCont-wNew)/2 : If (wCont-wNew) Mod 2 Then x = x - 1
                        y = (hCont-hNew)/2 : If (hCont-hNew) Mod 2 Then y = y - 1
                     Else
                        x = 0 : y = 0
                     End If
                     Graphic Render Icon fName$, (x,y)-(x+wNew-1,y+hNew-1)
                  Case ".bmp"
                     GetBMPSize fName$,wImg,hImg
                     StatusBarData$ = StatusBarData$ + "   Size: " + Str$(wImg) + " x" + Str$(hImg)
                     wNew = wImg / Max(wImg / wCont, hImg / hCont)  'wNew,hNew = image size to fit in container
                     hNew = hImg / Max(wImg / wCont, hImg / hCont)  'wNew,hNew = image size to fit in container
                     x = (wCont-wNew)/2 : If (wCont-wNew) Mod 2 Then x = x - 1
                     y = (hCont-hNew)/2 : If (hCont-hNew) Mod 2 Then y = y - 1
                     Graphic Attach hDlg, %IDC_Viewer
                     Graphic Render Bitmap fName$, (x,y)-(x+wNew-1,y+hNew-1)
                  Case ".jpg",".gif",".png
                     GetImageSize fName, wImg,hImg
                     StatusBarData$ = StatusBarData$ + "   Size: " + Str$(wImg) + " x" + Str$(hImg)
                     wNew = wImg / Max(wImg / wCont, hImg / hCont)  'wNew,hNew = image size to fit in container
                     hNew = hImg / Max(wImg / wCont, hImg / hCont)  'wNew,hNew = image size to fit in container
                     x = (wCont-wNew)/2 : If (wCont-wNew) Mod 2 Then x = x - 1
                     y = (hCont-hNew)/2 : If (hCont-hNew) Mod 2 Then y = y - 1
                     Graphic Bitmap New wImg, hImg To hBMP
                     Graphic Attach hBMP, 0
                     Graphic Color %Black, IIf(Transparent, -1, BGColor)
                     Graphic Clear
                     Graphic Get DC To hDC
                     LoadOtherImage fName$, hDC, 0, 0
                     Graphic Attach hDlg, %IDC_Viewer
                     Graphic Stretch hBMP, 0, (0,0)-(wImg-1,hImg-1) To (x,y)-(x+wNew-1,y+hNew-1)
               End Select
            Else    'fixed image size, starting in upper left corner of control
               Select Case fExt$
                  Case ".ico"
                     GetIconSize fName$,wImg,hImg
                     StatusBarData$ = StatusBarData$ + "   Size: " + Str$(wImg) + " x" + Str$(hImg)
                     If Centered Then
                        Graphic Get Client To wCont,hCont     'wCont,hCont = container size : hImg,wImg = original image size
                        If wImg < wCont Then x = (wCont-wImg)/2-1 Else x = 0
                        If hImg < hCont Then y = (hCont-hImg)/2-1 Else y = 0
                     Else
                        x = 0 : y = 0
                     End If
                     Graphic Render Icon fName$, (x,y)-(x+wImg-1,y+hImg-1)
                  Case ".bmp"
                     GetBMPSize fName$,wImg,hImg
                     StatusBarData$ = StatusBarData$ + "   Size: " + Str$(wImg) + " x" + Str$(hImg)
                     Graphic Attach hDlg, %IDC_Viewer
                     If Centered Then
                        Graphic Get Client To wCont,hCont     'wCont,hCont = container size : hImg,wImg = original image size
                        If wImg < wCont Then x = (wCont-wImg)/2-1 Else x = 0
                        If hImg < hCont Then y = (hCont-hImg)/2-1 Else y = 0
                     Else
                        x = 0 : y = 0
                     End If
                     Graphic Render Bitmap fName$, (x,y)-(x+wImg-1,y+hImg-1)
                  Case ".jpg",".gif",".png",".bmp"
                     GetImageSize fName, wImg,hImg
                     StatusBarData$ = StatusBarData$ + "   Size: " + Str$(wImg) + " x" + Str$(hImg)
                     If Centered Then
                        Graphic Get Client To wCont,hCont     'wCont,hCont = container size : hImg,wImg = original image size
                        If wImg < wCont Then x = (wCont-wImg)/2-1 Else x = 0
                        If hImg < hCont Then y = (hCont-hImg)/2-1 Else y = 0
                     Else
                        x = 0 : y = 0
                     End If
                     Graphic Get DC To hDC
                     LoadOtherImage fName$, hDC, x, y
               End Select
            End If
      Case %OtherFile
         'in work
   End Select
   Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, StatusBarData
End Sub

Sub LoadOtherImage(fName$, hDC As Dword, x As Long, y As Long)
   Local pImage,pGraphics As Dword, wFileName As WString
   'get image dimensions
   wFileName = fName$
   GdipLoadImageFromFile(StrPtr(wFileName), pImage)  'pImage - image object
   GdipCreateFromHDC(hDC, pGraphics)                        ' Create the Graphic object
   GdipDrawImage(pGraphics, pImage, x, y)                   ' Draw the image
   'GDIP cleanup
   If pImage Then GdipDisposeImage(pImage)
   If pGraphics Then GdipDeleteGraphics(pGraphics)
   Control ReDraw hDlg, %IDC_Viewer
End Sub

Sub GetIconSize(fName$, wImg As Long, hImg As Long)
   Local hIcon As Dword, P As IconInfo
   hIcon = LoadImage(GetModuleHandle(""), (fName$), %Image_Icon, 0, 0, %LR_LoadFromFile)
   GetIconInfo hIcon, P : DestroyIcon hIcon
   wImg = P.xHotSpot*2 : hImg = P.yHotSpot*2
End Sub

Sub GetBMPSize(fName$, wImg As Long, hImg As Long)
   Local hBMP As Dword
   Graphic Bitmap Load fName$, 0, 0 To hBMP
   Graphic Attach hBMP, 0
   Graphic Get Canvas To wImg,hImg
   Graphic Bitmap End
End Sub

Sub GetImageSize(fName$, wImg As Long, hImg As Long)
   Local wFileName As WString, pImage As Dword
   wFileName = fName$
   GdipLoadImageFromFile(StrPtr(wFileName), pImage)
   GdipGetImageWidth(pImage,wImg)
   GdipGetImageHeight(pImage,hImg)
   If pImage Then GdipDisposeImage(pImage)
End Sub

'unused
'w = w + 20 * IsTrue(GetWindowLong(hLVResults, %GWL_STYLE) And %WS_VScroll)

Sub CheckForUpdates(CurrentVer$)
   'Ver 2.1 (CheckforUpdates function only)

   'On the server, place
   'myapp.new --> myapp.exe renamed to myapp.new
   'myapp.ver --> version number of myapp.new, such as 1.0

   'CheckForUpdates function does these things
   '    --> downloads myapp.ver, compares it to local app version
   '    --> if user agrees, kill myapp.new then download myapp.new (please wait dialog w/progress bar appears)
   '    --> get appname, position, location from commandline
   '    --> Kill myapp.exe.old
   '   ---> renames myapp.exe as myapp.exe.old
   '   ---> renames myapp.new as myapp.exe
   '   ---> restart myapp.exe (which is the new version)

   Local LocalFilePath, URLSite, URLVerPath, URLFilePath, ServerVer As WStringZ * %Max_Path
   Local x,y,w,h,ServerFileSize As Long, Style, pid As Dword, Buffer, AllBytes As String
   Local locX As Long, locY As Long, sizeX As Long, sizeY As Long
   'local information
   LocalFilePath = Exe.Path$ + Exe.Name$ + ".new"   'location to put downloaded new EXE (renamed as NEW) file on local PC

   'server information
   URLSite = "www.garybeene.com"                                                 'server
   URLVerPath = "http://www.garybeene.com/files/" + LCase$(Exe.Name$) + ".ver"   'gives version number on server (myapp.ver)
   URLFilePath = "http://www.garybeene.com/files/" + LCase$(Exe.Name$) + ".new"  'is the latest EXE (named myapp.new)

   'clear the cache for the .new file
   DeleteURLCacheEntry(LocalFilePath)  '1 = success  clear the cache

   'read the .ver file from the server (not save, just read content into buffer)
   'if cannot get it tell user there was a problem and then exit Sub
   Tcp Open "HTTP" At URLSite As #1 TimeOut 60000
   Tcp Print #1, "GET  " + URLVerPath + "  HTTP/1.0"
   Tcp Print #1, ""
   Tcp Print #1, ""
   Tcp Recv #1, 4096, ServerVer    'this gets the Header + Body
   Tcp Close #1
   ServerVer = Remain$(ServerVer, $CrLf + $CrLf)   'this returns just the body

   'if ServerVer not newer than local version, tell user and then exit Sub
   Select Case Val(ServerVer)
      Case 0
         ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(MsgProc), GetModuleHandle(""), GetCurrentThreadId)
         MessageBox  0, "Update information not available!", "gbDuplicateFileFinder Online Update", %MB_Ok Or %MB_IconExclamation
         Exit Sub
      Case <= Val(CurrentVer$)
         ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(MsgProc), GetModuleHandle(""), GetCurrentThreadId)
         MessageBox 0, "You have the latest update!", "gbDuplicateFileFinder Online Update", %MB_Ok Or %MB_IconInformation
         Exit Sub
   End Select

   'server version is now verified as newer than local version
   'ask user for permission to proceed with download
   Style = %MB_OkCancel Or %MB_IconQuestion Or %MB_TaskModal
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(MsgProc), GetModuleHandle(""), GetCurrentThreadId)
   If MessageBox (0, "Update available. Download and install?", "Online Update", Style) = %IdCancel Then Exit Sub

   'before downloading, remove the existing .old and .new files, if they exist
   If IsFile(LocalFilePath) Then Kill LocalFilePath           'kill .new to clear the way

   'Get file size to use in download display status
    Tcp Open "HTTP" At URLSite As #1 TimeOut 60000
    Tcp Print #1, "HEAD  " + URLFilePath + "  HTTP/1.0"
    Tcp Print #1, "" : Tcp Print #1, ""
    Tcp Recv #1, 4096, Buffer : Tcp Close #1

    Buffer = Remain$(Buffer, "Content-Length:")
    ServerFileSize = Val(Extract$(Buffer, $CrLf))

    'Exit Sub if filesize is zero (tell user of the problem)
    If ServerFileSize = 0 Then
       ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(MsgProc), GetModuleHandle(""), GetCurrentThreadId)
       MessageBox 0, "Download file Not found!", "gbDuplicateFileFinder Online Update", %MB_Ok + %MB_IconExclamation
       Exit Sub
    End If

   'Display a Downloading ... PleaseWait dialog with a download status progress bar
   Dialog Get Client hDlg To w,h
   sizeX = 170 : sizeY = 90
   locX = (w-sizeX)/2    'gets left position of WaitDialog to center over app
   locY = (h-sizeY)/2    'gets top position of WaitDialog to center over app
   Dialog New Pixels, hDlg, "", locX, locY, sizeX, sizeY, %WS_Popup To hWait
   Control Add Label, hWait, %IDC_DownloadLabel, $CrLf + "Downloading ... please wait !", 0, 0, sizeX, sizeY, %SS_Center Or %WS_Border
   Control Set Color hWait, %IDC_DownloadLabel, %Black, %White
   Control Add Progressbar, hWait, %IDC_ProgressBar,"", 10,sizeY-40,sizeX-20,20   'bottom of dialog, but on top of label
   Dialog Show Modeless hWait

   'Download the file
   Tcp Open "http" At URLSite As #1 TimeOut 60000   'connect
   If Err Then Beep : Exit Sub
   Tcp Print #1, "GET " & URLFilePath & " HTTP/1.0"      'send the GET request
   Tcp Print #1, ""
   Do                                                              'get bytes until no more available
     Tcp Recv #1, 4096, Buffer
     AllBytes = AllBytes + Buffer
     Progressbar Set Pos hWait, %IDC_ProgressBar, (100*Len(AllBytes)/ServerFileSize)
   Loop While IsTrue Len(Buffer) And IsFalse Err
   Tcp Close #1                     'done, close the connection
   Dialog End hWait                'Remove the download status dialog

   If Len(AllBytes) = 0 Then
      'download failed. tell the user then exit sub
      ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(MsgProc), GetModuleHandle(""), GetCurrentThreadId)
      MessageBox 0, "Download of updated version failed!", "Online Update", %MB_Ok Or %MB_IconExclamation
      Exit Sub
   End If

   'Save the file, but first take off the HTTP header from the received bytes
   AllBytes  = Remain$(AllBytes, $CrLf + $CrLf)
   Open LocalFilePath For Binary As #1
   Put$ #1,AllBytes
   Close #1

   'the new application was successfully downloaded
   'Display a "Installation available. proceed? " dialog
   sizeX = 290 : sizeY = 80
   locX = (w-sizeX)/2    'gets left position of WaitDialog to center over app
   locY = (h-sizeY)/2    'gets top position of WaitDialog to center over app
   Dialog New Pixels, hDlg, "", locX, locY, sizeX, sizeY, %WS_SysMenu To hInstall
   Control Add Image, hInstall, %IDC_InstallImage, "aaa", 10, 10, 50,50, %WS_Border
   Control Add Label, hInstall, %IDC_InstallLabel, "Application is ready to install!", 75,15,270,20
   Control Add Button, hInstall, %IDC_InstallOk,"Install", 75,40,50,25
   Control Add Button, hInstall, %IDC_InstallCancel,"Cancel", 135,40,50,25
   Control Add CheckBox, hInstall, %IDC_InstallCheckBox,"Start on exit", 200,40,150,20
   Control Set Check hInstall, %IDC_InstallCheckBox, 1   'optional (start on exit)
   Dialog Show Modal hInstall Call InstallProc
End Sub

CallBack Function InstallProc() As Long
   Local iResult As Long
   Select Case Cb.Msg
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDC_InstallOk
               Control Get Check hInstall, %IDC_InstallCheckBox To Restart
               Dialog End hInstall
               Dialog End hDlg
            Case %IDC_InstallCancel
               Dialog End hInstall
         End Select
      Case %WM_Destroy
   End Select
End Function

Function InstallMsgProc(ByVal lMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long
   Dialog Get Loc hDlg To x,y
   x = x + 100 : y = y + 100        '<--- offset from upper left
   If lMsg = %HCBT_ACTIVATE Then
      SetWindowPos wParam, 0, x,y, 0, 0, %SWP_NOSIZE Or %SWP_NOACTIVATE Or %SWP_NOZORDER
      UnhookWindowsHookEx ghHook
   End If
End Function

Sub LoadStatusBar
   Local iResult As Long, fName$, fExt$, StatusBarData$, fText$
   Local wCont,hCont,wNew,hNew,x,y,w,h,wImg,hImg As Long, hBMP,hDC As Dword

   'determine file type of selected item
   ListView Get Select hDlg, %IDC_LVResults To iResult
   If iResult = 0 Then Exit Sub
   ListView Get Text hDlg, %IDC_LVResults, iResult, 4 To fName$
   If Len(fName$) = 0 Then Exit Sub
   StatusBarData$ = PathName$(Namex, fName$)
   fExt$ = LCase$(PathName$(Extn, fName$))

   Select Case LCase$(fExt$)
      Case ".bas", ".inc", ".bas", ".txt"
         SelectedFileType = %TextFile
      Case ".ico", ".bmp", ".jpg", ".gif", ".png"
         SelectedFileType = %ImageFile
      Case Else
         SelectedFileType = %OtherFile
   End Select

   If InStr(ValidTextExt, fExt$) Then
      fText$ = GetFileText(fName$)
      If Len(fText$) Then
         StatusBarData$ = StatusBarData$ + "   Line Count: " + Str$(ParseCount(fText$,$CrLf))
      Else
         StatusBarData$ = StatusBarData$ + "   Line Count:  0"
      End If
   ElseIf fExt$ = ".ico" Then
      GetIconSize fName$,wImg,hImg
      StatusBarData$ = StatusBarData$ + "   Size: " + Str$(wImg) + " x" + Str$(hImg)
   ElseIf fExt$ = ".bmp" Then
      GetBMPSize fName$,wImg,hImg
      StatusBarData$ = StatusBarData$ + "   Size: " + Str$(wImg) + " x" + Str$(hImg)
   ElseIf InStr(ValidImageExt,fExt$) Then
      GetImageSize fName, wImg,hImg
      StatusBarData$ = StatusBarData$ + "   Size: " + Str$(wImg) + " x" + Str$(hImg)
   End If
   Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, StatusBarData$
End Sub

Function RecycleBin(temp$) As Long
  Local shfo As SHFILEOPSTRUCTW, szSource As WStringZ * %Max_Path
  szSource = temp$
  shfo.wFunc = %FO_DELETE
  shfo.pFrom = VarPtr(szSource)
  shfo.fFlags = %FOF_ALLOWUNDO Or %FOF_NOCONFIRMATION
  SHFileOperation(shfo)
  Function = shfo.fAnyOperationsAborted  '%False=worked  %True=failed
End Function
